// A Bison parser, made by GNU Bison 3.8.2.

// Skeleton interface for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


/**
 ** \file src/asm/parser.hpp
 ** Define the yy::parser class.
 */

// C++ LALR(1) parser skeleton written by Akim Demaille.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.

#ifndef YY_YY_SRC_ASM_PARSER_HPP_INCLUDED
# define YY_YY_SRC_ASM_PARSER_HPP_INCLUDED
// "%code requires" blocks.
#line 7 "src/asm/parser.y"

	#include <stdint.h>
	#include <string>
	#include <variant>
	#include <vector>

	#include "asm/lexer.hpp"
	#include "asm/macro.hpp"
	#include "asm/rpn.hpp"
	#include "asm/section.hpp"

	#include "linkdefs.hpp"

	struct AlignmentSpec {
		uint8_t alignment;
		uint16_t alignOfs;
	};

	struct ForArgs {
		int32_t start;
		int32_t stop;
		int32_t step;
	};

	struct StrFmtArgList {
		std::string format;
		std::vector<std::variant<uint32_t, std::string>> args;

		StrFmtArgList() = default;
		StrFmtArgList(StrFmtArgList &&) = default;
	#ifdef _MSC_VER
		// MSVC and WinFlexBison won't build without this...
		StrFmtArgList(StrFmtArgList const &) = default;
	#endif

		StrFmtArgList &operator=(StrFmtArgList &&) = default;
	};

#line 88 "src/asm/parser.hpp"


# include <cstdlib> // std::abort
# include <iostream>
# include <stdexcept>
# include <string>
# include <vector>

#if defined __cplusplus
# define YY_CPLUSPLUS __cplusplus
#else
# define YY_CPLUSPLUS 199711L
#endif

// Support move semantics when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_MOVE           std::move
# define YY_MOVE_OR_COPY   move
# define YY_MOVE_REF(Type) Type&&
# define YY_RVREF(Type)    Type&&
# define YY_COPY(Type)     Type
#else
# define YY_MOVE
# define YY_MOVE_OR_COPY   copy
# define YY_MOVE_REF(Type) Type&
# define YY_RVREF(Type)    const Type&
# define YY_COPY(Type)     const Type&
#endif

// Support noexcept when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_NOEXCEPT noexcept
# define YY_NOTHROW
#else
# define YY_NOEXCEPT
# define YY_NOTHROW throw ()
#endif

// Support constexpr when possible.
#if 201703 <= YY_CPLUSPLUS
# define YY_CONSTEXPR constexpr
#else
# define YY_CONSTEXPR
#endif



#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

namespace yy {
#line 223 "src/asm/parser.hpp"




  /// A Bison parser.
  class parser
  {
  public:
#ifdef YYSTYPE
# ifdef __GNUC__
#  pragma GCC message "bison: do not #define YYSTYPE in C++, use %define api.value.type"
# endif
    typedef YYSTYPE value_type;
#else
  /// A buffer to store and retrieve objects.
  ///
  /// Sort of a variant, but does not keep track of the nature
  /// of the stored data, since that knowledge is available
  /// via the current parser state.
  class value_type
  {
  public:
    /// Type of *this.
    typedef value_type self_type;

    /// Empty construction.
    value_type () YY_NOEXCEPT
      : yyraw_ ()
    {}

    /// Construct and fill.
    template <typename T>
    value_type (YY_RVREF (T) t)
    {
      new (yyas_<T> ()) T (YY_MOVE (t));
    }

#if 201103L <= YY_CPLUSPLUS
    /// Non copyable.
    value_type (const self_type&) = delete;
    /// Non copyable.
    self_type& operator= (const self_type&) = delete;
#endif

    /// Destruction, allowed only if empty.
    ~value_type () YY_NOEXCEPT
    {}

# if 201103L <= YY_CPLUSPLUS
    /// Instantiate a \a T in here from \a t.
    template <typename T, typename... U>
    T&
    emplace (U&&... u)
    {
      return *new (yyas_<T> ()) T (std::forward <U>(u)...);
    }
# else
    /// Instantiate an empty \a T in here.
    template <typename T>
    T&
    emplace ()
    {
      return *new (yyas_<T> ()) T ();
    }

    /// Instantiate a \a T in here from \a t.
    template <typename T>
    T&
    emplace (const T& t)
    {
      return *new (yyas_<T> ()) T (t);
    }
# endif

    /// Instantiate an empty \a T in here.
    /// Obsolete, use emplace.
    template <typename T>
    T&
    build ()
    {
      return emplace<T> ();
    }

    /// Instantiate a \a T in here from \a t.
    /// Obsolete, use emplace.
    template <typename T>
    T&
    build (const T& t)
    {
      return emplace<T> (t);
    }

    /// Accessor to a built \a T.
    template <typename T>
    T&
    as () YY_NOEXCEPT
    {
      return *yyas_<T> ();
    }

    /// Const accessor to a built \a T (for %printer).
    template <typename T>
    const T&
    as () const YY_NOEXCEPT
    {
      return *yyas_<T> ();
    }

    /// Swap the content with \a that, of same type.
    ///
    /// Both variants must be built beforehand, because swapping the actual
    /// data requires reading it (with as()), and this is not possible on
    /// unconstructed variants: it would require some dynamic testing, which
    /// should not be the variant's responsibility.
    /// Swapping between built and (possibly) non-built is done with
    /// self_type::move ().
    template <typename T>
    void
    swap (self_type& that) YY_NOEXCEPT
    {
      std::swap (as<T> (), that.as<T> ());
    }

    /// Move the content of \a that to this.
    ///
    /// Destroys \a that.
    template <typename T>
    void
    move (self_type& that)
    {
# if 201103L <= YY_CPLUSPLUS
      emplace<T> (std::move (that.as<T> ()));
# else
      emplace<T> ();
      swap<T> (that);
# endif
      that.destroy<T> ();
    }

# if 201103L <= YY_CPLUSPLUS
    /// Move the content of \a that to this.
    template <typename T>
    void
    move (self_type&& that)
    {
      emplace<T> (std::move (that.as<T> ()));
      that.destroy<T> ();
    }
#endif

    /// Copy the content of \a that to this.
    template <typename T>
    void
    copy (const self_type& that)
    {
      emplace<T> (that.as<T> ());
    }

    /// Destroy the stored \a T.
    template <typename T>
    void
    destroy ()
    {
      as<T> ().~T ();
    }

  private:
#if YY_CPLUSPLUS < 201103L
    /// Non copyable.
    value_type (const self_type&);
    /// Non copyable.
    self_type& operator= (const self_type&);
#endif

    /// Accessor to raw memory as \a T.
    template <typename T>
    T*
    yyas_ () YY_NOEXCEPT
    {
      void *yyp = yyraw_;
      return static_cast<T*> (yyp);
     }

    /// Const accessor to raw memory as \a T.
    template <typename T>
    const T*
    yyas_ () const YY_NOEXCEPT
    {
      const void *yyp = yyraw_;
      return static_cast<const T*> (yyp);
     }

    /// An auxiliary type to compute the largest semantic type.
    union union_type
    {
      // align_spec
      char dummy1[sizeof (AlignmentSpec)];

      // assert_type
      char dummy2[sizeof (AssertionType)];

      // capture_rept
      // capture_macro
      char dummy3[sizeof (Capture)];

      // reloc_8bit
      // reloc_8bit_no_str
      // reloc_8bit_offset
      // reloc_16bit
      // reloc_16bit_no_str
      // relocexpr
      // relocexpr_no_str
      // op_mem_ind
      // op_a_n
      char dummy4[sizeof (Expression)];

      // for_args
      char dummy5[sizeof (ForArgs)];

      // compound_eq
      char dummy6[sizeof (RPNCommand)];

      // sect_mod
      char dummy7[sizeof (SectionModifier)];

      // sect_attrs
      char dummy8[sizeof (SectionSpec)];

      // strfmt_args
      // strfmt_va_args
      char dummy9[sizeof (StrFmtArgList)];

      // "number"
      // shift_const
      // rs_uconst
      // bit_const
      // uconst
      // const
      // const_no_str
      // const_8bit
      // opt_q_arg
      // sect_type
      // sect_org
      // op_a_r
      // ccode_expr
      // ccode
      // reg_r
      // reg_r_no_a
      // reg_a
      // reg_tt
      // reg_ss
      // reg_rr
      char dummy10[sizeof (int32_t)];

      // macro_args
      char dummy11[sizeof (std::shared_ptr<MacroArgs>)];

      // "string"
      // "label"
      // "identifier"
      // "local identifier"
      // "anonymous label"
      // def_id
      // redef_id
      // scoped_id
      // scoped_anon_id
      // string
      // strcat_args
      char dummy12[sizeof (std::string)];

      // ds_args
      char dummy13[sizeof (std::vector<Expression>)];

      // purge_args
      char dummy14[sizeof (std::vector<std::string>)];
    };

    /// The size of the largest semantic type.
    enum { size = sizeof (union_type) };

    /// A buffer to store semantic values.
    union
    {
      /// Strongest alignment constraints.
      long double yyalign_me_;
      /// A buffer large enough to store any of the semantic values.
      char yyraw_[size];
    };
  };

#endif
    /// Backward compatibility (Bison 3.8).
    typedef value_type semantic_type;


    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
      syntax_error (const std::string& m)
        : std::runtime_error (m)
      {}

      syntax_error (const syntax_error& s)
        : std::runtime_error (s.what ())
      {}

      ~syntax_error () YY_NOEXCEPT YY_NOTHROW;
    };

    /// Token kinds.
    struct token
    {
      enum token_kind_type
      {
        YYEMPTY = -2,
    YYEOF = 0,                     // "end of file"
    YYerror = 1,                   // error
    YYUNDEF = 2,                   // "invalid token"
    NUMBER = 3,                    // "number"
    STRING = 4,                    // "string"
    PERIOD = 5,                    // "."
    COMMA = 6,                     // ","
    COLON = 7,                     // ":"
    DOUBLE_COLON = 8,              // "::"
    LBRACK = 9,                    // "["
    RBRACK = 10,                   // "]"
    LPAREN = 11,                   // "("
    RPAREN = 12,                   // ")"
    NEWLINE = 13,                  // "newline"
    OP_LOGICNOT = 14,              // "!"
    OP_LOGICAND = 15,              // "&&"
    OP_LOGICOR = 16,               // "||"
    OP_LOGICGT = 17,               // ">"
    OP_LOGICLT = 18,               // "<"
    OP_LOGICGE = 19,               // ">="
    OP_LOGICLE = 20,               // "<="
    OP_LOGICNE = 21,               // "!="
    OP_LOGICEQU = 22,              // "=="
    OP_ADD = 23,                   // "+"
    OP_SUB = 24,                   // "-"
    OP_OR = 25,                    // "|"
    OP_XOR = 26,                   // "^"
    OP_AND = 27,                   // "&"
    OP_SHL = 28,                   // "<<"
    OP_SHR = 29,                   // ">>"
    OP_USHR = 30,                  // ">>>"
    OP_MUL = 31,                   // "*"
    OP_DIV = 32,                   // "/"
    OP_MOD = 33,                   // "%"
    OP_NOT = 34,                   // "~"
    NEG = 35,                      // NEG
    OP_EXP = 36,                   // "**"
    OP_DEF = 37,                   // "DEF"
    OP_BANK = 38,                  // "BANK"
    OP_ALIGN = 39,                 // "ALIGN"
    OP_SIZEOF = 40,                // "SIZEOF"
    OP_STARTOF = 41,               // "STARTOF"
    OP_SIN = 42,                   // "SIN"
    OP_COS = 43,                   // "COS"
    OP_TAN = 44,                   // "TAN"
    OP_ASIN = 45,                  // "ASIN"
    OP_ACOS = 46,                  // "ACOS"
    OP_ATAN = 47,                  // "ATAN"
    OP_ATAN2 = 48,                 // "ATAN2"
    OP_FDIV = 49,                  // "FDIV"
    OP_FMUL = 50,                  // "FMUL"
    OP_FMOD = 51,                  // "FMOD"
    OP_POW = 52,                   // "POW"
    OP_LOG = 53,                   // "LOG"
    OP_ROUND = 54,                 // "ROUND"
    OP_CEIL = 55,                  // "CEIL"
    OP_FLOOR = 56,                 // "FLOOR"
    OP_HIGH = 57,                  // "HIGH"
    OP_LOW = 58,                   // "LOW"
    OP_ISCONST = 59,               // "ISCONST"
    OP_STRCMP = 60,                // "STRCMP"
    OP_STRIN = 61,                 // "STRIN"
    OP_STRRIN = 62,                // "STRRIN"
    OP_STRSUB = 63,                // "STRSUB"
    OP_STRLEN = 64,                // "STRLEN"
    OP_STRCAT = 65,                // "STRCAT"
    OP_STRUPR = 66,                // "STRUPR"
    OP_STRLWR = 67,                // "STRLWR"
    OP_STRRPL = 68,                // "STRRPL"
    OP_STRFMT = 69,                // "STRFMT"
    OP_CHARLEN = 70,               // "CHARLEN"
    OP_CHARSUB = 71,               // "CHARSUB"
    OP_INCHARMAP = 72,             // "INCHARMAP"
    LABEL = 73,                    // "label"
    ID = 74,                       // "identifier"
    LOCAL_ID = 75,                 // "local identifier"
    ANON = 76,                     // "anonymous label"
    POP_EQU = 77,                  // "EQU"
    POP_EQUAL = 78,                // "="
    POP_EQUS = 79,                 // "EQUS"
    POP_ADDEQ = 80,                // "+="
    POP_SUBEQ = 81,                // "-="
    POP_MULEQ = 82,                // "*="
    POP_DIVEQ = 83,                // "/="
    POP_MODEQ = 84,                // "%="
    POP_OREQ = 85,                 // "|="
    POP_XOREQ = 86,                // "^="
    POP_ANDEQ = 87,                // "&="
    POP_SHLEQ = 88,                // "<<="
    POP_SHREQ = 89,                // ">>="
    POP_INCLUDE = 90,              // "INCLUDE"
    POP_PRINT = 91,                // "PRINT"
    POP_PRINTLN = 92,              // "PRINTLN"
    POP_IF = 93,                   // "IF"
    POP_ELIF = 94,                 // "ELIF"
    POP_ELSE = 95,                 // "ELSE"
    POP_ENDC = 96,                 // "ENDC"
    POP_EXPORT = 97,               // "EXPORT"
    POP_DB = 98,                   // "DB"
    POP_DS = 99,                   // "DS"
    POP_DW = 100,                  // "DW"
    POP_DL = 101,                  // "DL"
    POP_SECTION = 102,             // "SECTION"
    POP_FRAGMENT = 103,            // "FRAGMENT"
    POP_ENDSECTION = 104,          // "ENDSECTION"
    POP_RB = 105,                  // "RB"
    POP_RW = 106,                  // "RW"
    POP_MACRO = 107,               // "MACRO"
    POP_ENDM = 108,                // "ENDM"
    POP_RSRESET = 109,             // "RSRESET"
    POP_RSSET = 110,               // "RSSET"
    POP_UNION = 111,               // "UNION"
    POP_NEXTU = 112,               // "NEXTU"
    POP_ENDU = 113,                // "ENDU"
    POP_INCBIN = 114,              // "INCBIN"
    POP_REPT = 115,                // "REPT"
    POP_FOR = 116,                 // "FOR"
    POP_CHARMAP = 117,             // "CHARMAP"
    POP_NEWCHARMAP = 118,          // "NEWCHARMAP"
    POP_SETCHARMAP = 119,          // "SETCHARMAP"
    POP_PUSHC = 120,               // "PUSHC"
    POP_POPC = 121,                // "POPC"
    POP_SHIFT = 122,               // "SHIFT"
    POP_ENDR = 123,                // "ENDR"
    POP_BREAK = 124,               // "BREAK"
    POP_LOAD = 125,                // "LOAD"
    POP_ENDL = 126,                // "ENDL"
    POP_FAIL = 127,                // "FAIL"
    POP_WARN = 128,                // "WARN"
    POP_FATAL = 129,               // "FATAL"
    POP_ASSERT = 130,              // "ASSERT"
    POP_STATIC_ASSERT = 131,       // "STATIC_ASSERT"
    POP_PURGE = 132,               // "PURGE"
    POP_REDEF = 133,               // "REDEF"
    POP_POPS = 134,                // "POPS"
    POP_PUSHS = 135,               // "PUSHS"
    POP_POPO = 136,                // "POPO"
    POP_PUSHO = 137,               // "PUSHO"
    POP_OPT = 138,                 // "OPT"
    SECT_ROM0 = 139,               // "ROM0"
    SECT_ROMX = 140,               // "ROMX"
    SECT_WRAM0 = 141,              // "WRAM0"
    SECT_WRAMX = 142,              // "WRAMX"
    SECT_HRAM = 143,               // "HRAM"
    SECT_VRAM = 144,               // "VRAM"
    SECT_SRAM = 145,               // "SRAM"
    SECT_OAM = 146,                // "OAM"
    Z80_ADC = 147,                 // "adc"
    Z80_ADD = 148,                 // "add"
    Z80_AND = 149,                 // "and"
    Z80_BIT = 150,                 // "bit"
    Z80_CALL = 151,                // "call"
    Z80_CCF = 152,                 // "ccf"
    Z80_CP = 153,                  // "cp"
    Z80_CPL = 154,                 // "cpl"
    Z80_DAA = 155,                 // "daa"
    Z80_DEC = 156,                 // "dec"
    Z80_DI = 157,                  // "di"
    Z80_EI = 158,                  // "ei"
    Z80_HALT = 159,                // "halt"
    Z80_INC = 160,                 // "inc"
    Z80_JP = 161,                  // "jp"
    Z80_JR = 162,                  // "jr"
    Z80_LD = 163,                  // "ld"
    Z80_LDI = 164,                 // "ldi"
    Z80_LDD = 165,                 // "ldd"
    Z80_LDH = 166,                 // "ldh"
    Z80_NOP = 167,                 // "nop"
    Z80_OR = 168,                  // "or"
    Z80_POP = 169,                 // "pop"
    Z80_PUSH = 170,                // "push"
    Z80_RES = 171,                 // "res"
    Z80_RET = 172,                 // "ret"
    Z80_RETI = 173,                // "reti"
    Z80_RST = 174,                 // "rst"
    Z80_RL = 175,                  // "rl"
    Z80_RLA = 176,                 // "rla"
    Z80_RLC = 177,                 // "rlc"
    Z80_RLCA = 178,                // "rlca"
    Z80_RR = 179,                  // "rr"
    Z80_RRA = 180,                 // "rra"
    Z80_RRC = 181,                 // "rrc"
    Z80_RRCA = 182,                // "rrca"
    Z80_SBC = 183,                 // "sbc"
    Z80_SCF = 184,                 // "scf"
    Z80_SET = 185,                 // "set"
    Z80_STOP = 186,                // "stop"
    Z80_SLA = 187,                 // "sla"
    Z80_SRA = 188,                 // "sra"
    Z80_SRL = 189,                 // "srl"
    Z80_SUB = 190,                 // "sub"
    Z80_SWAP = 191,                // "swap"
    Z80_XOR = 192,                 // "xor"
    TOKEN_A = 193,                 // "a"
    TOKEN_B = 194,                 // "b"
    TOKEN_C = 195,                 // "c"
    TOKEN_D = 196,                 // "d"
    TOKEN_E = 197,                 // "e"
    TOKEN_H = 198,                 // "h"
    TOKEN_L = 199,                 // "l"
    MODE_AF = 200,                 // "af"
    MODE_BC = 201,                 // "bc"
    MODE_DE = 202,                 // "de"
    MODE_SP = 203,                 // "sp"
    MODE_HL = 204,                 // "hl"
    MODE_HL_DEC = 205,             // "hld/hl-"
    MODE_HL_INC = 206,             // "hli/hl+"
    CC_NZ = 207,                   // "nz"
    CC_Z = 208,                    // "z"
    CC_NC = 209,                   // "nc"
    EOB = 210                      // "end of buffer"
      };
      /// Backward compatibility alias (Bison 3.6).
      typedef token_kind_type yytokentype;
    };

    /// Token kind, as returned by yylex.
    typedef token::token_kind_type token_kind_type;

    /// Backward compatibility alias (Bison 3.6).
    typedef token_kind_type token_type;

    /// Symbol kinds.
    struct symbol_kind
    {
      enum symbol_kind_type
      {
        YYNTOKENS = 211, ///< Number of tokens.
        S_YYEMPTY = -2,
        S_YYEOF = 0,                             // "end of file"
        S_YYerror = 1,                           // error
        S_YYUNDEF = 2,                           // "invalid token"
        S_NUMBER = 3,                            // "number"
        S_STRING = 4,                            // "string"
        S_PERIOD = 5,                            // "."
        S_COMMA = 6,                             // ","
        S_COLON = 7,                             // ":"
        S_DOUBLE_COLON = 8,                      // "::"
        S_LBRACK = 9,                            // "["
        S_RBRACK = 10,                           // "]"
        S_LPAREN = 11,                           // "("
        S_RPAREN = 12,                           // ")"
        S_NEWLINE = 13,                          // "newline"
        S_OP_LOGICNOT = 14,                      // "!"
        S_OP_LOGICAND = 15,                      // "&&"
        S_OP_LOGICOR = 16,                       // "||"
        S_OP_LOGICGT = 17,                       // ">"
        S_OP_LOGICLT = 18,                       // "<"
        S_OP_LOGICGE = 19,                       // ">="
        S_OP_LOGICLE = 20,                       // "<="
        S_OP_LOGICNE = 21,                       // "!="
        S_OP_LOGICEQU = 22,                      // "=="
        S_OP_ADD = 23,                           // "+"
        S_OP_SUB = 24,                           // "-"
        S_OP_OR = 25,                            // "|"
        S_OP_XOR = 26,                           // "^"
        S_OP_AND = 27,                           // "&"
        S_OP_SHL = 28,                           // "<<"
        S_OP_SHR = 29,                           // ">>"
        S_OP_USHR = 30,                          // ">>>"
        S_OP_MUL = 31,                           // "*"
        S_OP_DIV = 32,                           // "/"
        S_OP_MOD = 33,                           // "%"
        S_OP_NOT = 34,                           // "~"
        S_NEG = 35,                              // NEG
        S_OP_EXP = 36,                           // "**"
        S_OP_DEF = 37,                           // "DEF"
        S_OP_BANK = 38,                          // "BANK"
        S_OP_ALIGN = 39,                         // "ALIGN"
        S_OP_SIZEOF = 40,                        // "SIZEOF"
        S_OP_STARTOF = 41,                       // "STARTOF"
        S_OP_SIN = 42,                           // "SIN"
        S_OP_COS = 43,                           // "COS"
        S_OP_TAN = 44,                           // "TAN"
        S_OP_ASIN = 45,                          // "ASIN"
        S_OP_ACOS = 46,                          // "ACOS"
        S_OP_ATAN = 47,                          // "ATAN"
        S_OP_ATAN2 = 48,                         // "ATAN2"
        S_OP_FDIV = 49,                          // "FDIV"
        S_OP_FMUL = 50,                          // "FMUL"
        S_OP_FMOD = 51,                          // "FMOD"
        S_OP_POW = 52,                           // "POW"
        S_OP_LOG = 53,                           // "LOG"
        S_OP_ROUND = 54,                         // "ROUND"
        S_OP_CEIL = 55,                          // "CEIL"
        S_OP_FLOOR = 56,                         // "FLOOR"
        S_OP_HIGH = 57,                          // "HIGH"
        S_OP_LOW = 58,                           // "LOW"
        S_OP_ISCONST = 59,                       // "ISCONST"
        S_OP_STRCMP = 60,                        // "STRCMP"
        S_OP_STRIN = 61,                         // "STRIN"
        S_OP_STRRIN = 62,                        // "STRRIN"
        S_OP_STRSUB = 63,                        // "STRSUB"
        S_OP_STRLEN = 64,                        // "STRLEN"
        S_OP_STRCAT = 65,                        // "STRCAT"
        S_OP_STRUPR = 66,                        // "STRUPR"
        S_OP_STRLWR = 67,                        // "STRLWR"
        S_OP_STRRPL = 68,                        // "STRRPL"
        S_OP_STRFMT = 69,                        // "STRFMT"
        S_OP_CHARLEN = 70,                       // "CHARLEN"
        S_OP_CHARSUB = 71,                       // "CHARSUB"
        S_OP_INCHARMAP = 72,                     // "INCHARMAP"
        S_LABEL = 73,                            // "label"
        S_ID = 74,                               // "identifier"
        S_LOCAL_ID = 75,                         // "local identifier"
        S_ANON = 76,                             // "anonymous label"
        S_POP_EQU = 77,                          // "EQU"
        S_POP_EQUAL = 78,                        // "="
        S_POP_EQUS = 79,                         // "EQUS"
        S_POP_ADDEQ = 80,                        // "+="
        S_POP_SUBEQ = 81,                        // "-="
        S_POP_MULEQ = 82,                        // "*="
        S_POP_DIVEQ = 83,                        // "/="
        S_POP_MODEQ = 84,                        // "%="
        S_POP_OREQ = 85,                         // "|="
        S_POP_XOREQ = 86,                        // "^="
        S_POP_ANDEQ = 87,                        // "&="
        S_POP_SHLEQ = 88,                        // "<<="
        S_POP_SHREQ = 89,                        // ">>="
        S_POP_INCLUDE = 90,                      // "INCLUDE"
        S_POP_PRINT = 91,                        // "PRINT"
        S_POP_PRINTLN = 92,                      // "PRINTLN"
        S_POP_IF = 93,                           // "IF"
        S_POP_ELIF = 94,                         // "ELIF"
        S_POP_ELSE = 95,                         // "ELSE"
        S_POP_ENDC = 96,                         // "ENDC"
        S_POP_EXPORT = 97,                       // "EXPORT"
        S_POP_DB = 98,                           // "DB"
        S_POP_DS = 99,                           // "DS"
        S_POP_DW = 100,                          // "DW"
        S_POP_DL = 101,                          // "DL"
        S_POP_SECTION = 102,                     // "SECTION"
        S_POP_FRAGMENT = 103,                    // "FRAGMENT"
        S_POP_ENDSECTION = 104,                  // "ENDSECTION"
        S_POP_RB = 105,                          // "RB"
        S_POP_RW = 106,                          // "RW"
        S_POP_MACRO = 107,                       // "MACRO"
        S_POP_ENDM = 108,                        // "ENDM"
        S_POP_RSRESET = 109,                     // "RSRESET"
        S_POP_RSSET = 110,                       // "RSSET"
        S_POP_UNION = 111,                       // "UNION"
        S_POP_NEXTU = 112,                       // "NEXTU"
        S_POP_ENDU = 113,                        // "ENDU"
        S_POP_INCBIN = 114,                      // "INCBIN"
        S_POP_REPT = 115,                        // "REPT"
        S_POP_FOR = 116,                         // "FOR"
        S_POP_CHARMAP = 117,                     // "CHARMAP"
        S_POP_NEWCHARMAP = 118,                  // "NEWCHARMAP"
        S_POP_SETCHARMAP = 119,                  // "SETCHARMAP"
        S_POP_PUSHC = 120,                       // "PUSHC"
        S_POP_POPC = 121,                        // "POPC"
        S_POP_SHIFT = 122,                       // "SHIFT"
        S_POP_ENDR = 123,                        // "ENDR"
        S_POP_BREAK = 124,                       // "BREAK"
        S_POP_LOAD = 125,                        // "LOAD"
        S_POP_ENDL = 126,                        // "ENDL"
        S_POP_FAIL = 127,                        // "FAIL"
        S_POP_WARN = 128,                        // "WARN"
        S_POP_FATAL = 129,                       // "FATAL"
        S_POP_ASSERT = 130,                      // "ASSERT"
        S_POP_STATIC_ASSERT = 131,               // "STATIC_ASSERT"
        S_POP_PURGE = 132,                       // "PURGE"
        S_POP_REDEF = 133,                       // "REDEF"
        S_POP_POPS = 134,                        // "POPS"
        S_POP_PUSHS = 135,                       // "PUSHS"
        S_POP_POPO = 136,                        // "POPO"
        S_POP_PUSHO = 137,                       // "PUSHO"
        S_POP_OPT = 138,                         // "OPT"
        S_SECT_ROM0 = 139,                       // "ROM0"
        S_SECT_ROMX = 140,                       // "ROMX"
        S_SECT_WRAM0 = 141,                      // "WRAM0"
        S_SECT_WRAMX = 142,                      // "WRAMX"
        S_SECT_HRAM = 143,                       // "HRAM"
        S_SECT_VRAM = 144,                       // "VRAM"
        S_SECT_SRAM = 145,                       // "SRAM"
        S_SECT_OAM = 146,                        // "OAM"
        S_Z80_ADC = 147,                         // "adc"
        S_Z80_ADD = 148,                         // "add"
        S_Z80_AND = 149,                         // "and"
        S_Z80_BIT = 150,                         // "bit"
        S_Z80_CALL = 151,                        // "call"
        S_Z80_CCF = 152,                         // "ccf"
        S_Z80_CP = 153,                          // "cp"
        S_Z80_CPL = 154,                         // "cpl"
        S_Z80_DAA = 155,                         // "daa"
        S_Z80_DEC = 156,                         // "dec"
        S_Z80_DI = 157,                          // "di"
        S_Z80_EI = 158,                          // "ei"
        S_Z80_HALT = 159,                        // "halt"
        S_Z80_INC = 160,                         // "inc"
        S_Z80_JP = 161,                          // "jp"
        S_Z80_JR = 162,                          // "jr"
        S_Z80_LD = 163,                          // "ld"
        S_Z80_LDI = 164,                         // "ldi"
        S_Z80_LDD = 165,                         // "ldd"
        S_Z80_LDH = 166,                         // "ldh"
        S_Z80_NOP = 167,                         // "nop"
        S_Z80_OR = 168,                          // "or"
        S_Z80_POP = 169,                         // "pop"
        S_Z80_PUSH = 170,                        // "push"
        S_Z80_RES = 171,                         // "res"
        S_Z80_RET = 172,                         // "ret"
        S_Z80_RETI = 173,                        // "reti"
        S_Z80_RST = 174,                         // "rst"
        S_Z80_RL = 175,                          // "rl"
        S_Z80_RLA = 176,                         // "rla"
        S_Z80_RLC = 177,                         // "rlc"
        S_Z80_RLCA = 178,                        // "rlca"
        S_Z80_RR = 179,                          // "rr"
        S_Z80_RRA = 180,                         // "rra"
        S_Z80_RRC = 181,                         // "rrc"
        S_Z80_RRCA = 182,                        // "rrca"
        S_Z80_SBC = 183,                         // "sbc"
        S_Z80_SCF = 184,                         // "scf"
        S_Z80_SET = 185,                         // "set"
        S_Z80_STOP = 186,                        // "stop"
        S_Z80_SLA = 187,                         // "sla"
        S_Z80_SRA = 188,                         // "sra"
        S_Z80_SRL = 189,                         // "srl"
        S_Z80_SUB = 190,                         // "sub"
        S_Z80_SWAP = 191,                        // "swap"
        S_Z80_XOR = 192,                         // "xor"
        S_TOKEN_A = 193,                         // "a"
        S_TOKEN_B = 194,                         // "b"
        S_TOKEN_C = 195,                         // "c"
        S_TOKEN_D = 196,                         // "d"
        S_TOKEN_E = 197,                         // "e"
        S_TOKEN_H = 198,                         // "h"
        S_TOKEN_L = 199,                         // "l"
        S_MODE_AF = 200,                         // "af"
        S_MODE_BC = 201,                         // "bc"
        S_MODE_DE = 202,                         // "de"
        S_MODE_SP = 203,                         // "sp"
        S_MODE_HL = 204,                         // "hl"
        S_MODE_HL_DEC = 205,                     // "hld/hl-"
        S_MODE_HL_INC = 206,                     // "hli/hl+"
        S_CC_NZ = 207,                           // "nz"
        S_CC_Z = 208,                            // "z"
        S_CC_NC = 209,                           // "nc"
        S_EOB = 210,                             // "end of buffer"
        S_YYACCEPT = 211,                        // $accept
        S_asm_file = 212,                        // asm_file
        S_lines = 213,                           // lines
        S_endofline = 214,                       // endofline
        S_opt_diff_mark = 215,                   // opt_diff_mark
        S_line = 216,                            // line
        S_217_1 = 217,                           // $@1
        S_218_2 = 218,                           // $@2
        S_line_directive = 219,                  // line_directive
        S_if = 220,                              // if
        S_elif = 221,                            // elif
        S_else = 222,                            // else
        S_plain_directive = 223,                 // plain_directive
        S_endc = 224,                            // endc
        S_def_id = 225,                          // def_id
        S_226_3 = 226,                           // $@3
        S_redef_id = 227,                        // redef_id
        S_228_4 = 228,                           // $@4
        S_scoped_id = 229,                       // scoped_id
        S_scoped_anon_id = 230,                  // scoped_anon_id
        S_label = 231,                           // label
        S_macro = 232,                           // macro
        S_233_5 = 233,                           // $@5
        S_macro_args = 234,                      // macro_args
        S_directive = 235,                       // directive
        S_trailing_comma = 236,                  // trailing_comma
        S_compound_eq = 237,                     // compound_eq
        S_align = 238,                           // align
        S_align_spec = 239,                      // align_spec
        S_opt = 240,                             // opt
        S_241_6 = 241,                           // $@6
        S_opt_list = 242,                        // opt_list
        S_opt_list_entry = 243,                  // opt_list_entry
        S_popo = 244,                            // popo
        S_pusho = 245,                           // pusho
        S_pops = 246,                            // pops
        S_pushs = 247,                           // pushs
        S_endsection = 248,                      // endsection
        S_fail = 249,                            // fail
        S_warn = 250,                            // warn
        S_assert_type = 251,                     // assert_type
        S_assert = 252,                          // assert
        S_shift = 253,                           // shift
        S_shift_const = 254,                     // shift_const
        S_load = 255,                            // load
        S_rept = 256,                            // rept
        S_for = 257,                             // for
        S_258_7 = 258,                           // $@7
        S_259_8 = 259,                           // $@8
        S_capture_rept = 260,                    // capture_rept
        S_for_args = 261,                        // for_args
        S_break = 262,                           // break
        S_def_macro = 263,                       // def_macro
        S_264_9 = 264,                           // $@9
        S_265_10 = 265,                          // $@10
        S_capture_macro = 266,                   // capture_macro
        S_rsset = 267,                           // rsset
        S_rsreset = 268,                         // rsreset
        S_rs_uconst = 269,                       // rs_uconst
        S_union = 270,                           // union
        S_nextu = 271,                           // nextu
        S_endu = 272,                            // endu
        S_ds = 273,                              // ds
        S_ds_args = 274,                         // ds_args
        S_db = 275,                              // db
        S_dw = 276,                              // dw
        S_dl = 277,                              // dl
        S_def_equ = 278,                         // def_equ
        S_redef_equ = 279,                       // redef_equ
        S_def_set = 280,                         // def_set
        S_def_rb = 281,                          // def_rb
        S_def_rw = 282,                          // def_rw
        S_def_rl = 283,                          // def_rl
        S_def_equs = 284,                        // def_equs
        S_redef_equs = 285,                      // redef_equs
        S_purge = 286,                           // purge
        S_287_11 = 287,                          // $@11
        S_purge_args = 288,                      // purge_args
        S_export = 289,                          // export
        S_export_list = 290,                     // export_list
        S_export_list_entry = 291,               // export_list_entry
        S_include = 292,                         // include
        S_incbin = 293,                          // incbin
        S_charmap = 294,                         // charmap
        S_newcharmap = 295,                      // newcharmap
        S_setcharmap = 296,                      // setcharmap
        S_pushc = 297,                           // pushc
        S_popc = 298,                            // popc
        S_print = 299,                           // print
        S_println = 300,                         // println
        S_print_exprs = 301,                     // print_exprs
        S_print_expr = 302,                      // print_expr
        S_bit_const = 303,                       // bit_const
        S_constlist_8bit = 304,                  // constlist_8bit
        S_constlist_8bit_entry = 305,            // constlist_8bit_entry
        S_constlist_16bit = 306,                 // constlist_16bit
        S_constlist_16bit_entry = 307,           // constlist_16bit_entry
        S_constlist_32bit = 308,                 // constlist_32bit
        S_constlist_32bit_entry = 309,           // constlist_32bit_entry
        S_reloc_8bit = 310,                      // reloc_8bit
        S_reloc_8bit_no_str = 311,               // reloc_8bit_no_str
        S_reloc_8bit_offset = 312,               // reloc_8bit_offset
        S_reloc_16bit = 313,                     // reloc_16bit
        S_reloc_16bit_no_str = 314,              // reloc_16bit_no_str
        S_relocexpr = 315,                       // relocexpr
        S_relocexpr_no_str = 316,                // relocexpr_no_str
        S_317_12 = 317,                          // $@12
        S_uconst = 318,                          // uconst
        S_const = 319,                           // const
        S_const_no_str = 320,                    // const_no_str
        S_const_8bit = 321,                      // const_8bit
        S_opt_q_arg = 322,                       // opt_q_arg
        S_string = 323,                          // string
        S_strcat_args = 324,                     // strcat_args
        S_strfmt_args = 325,                     // strfmt_args
        S_strfmt_va_args = 326,                  // strfmt_va_args
        S_section = 327,                         // section
        S_sect_mod = 328,                        // sect_mod
        S_sect_type = 329,                       // sect_type
        S_sect_org = 330,                        // sect_org
        S_sect_attrs = 331,                      // sect_attrs
        S_cpu_commands = 332,                    // cpu_commands
        S_cpu_command = 333,                     // cpu_command
        S_z80_adc = 334,                         // z80_adc
        S_z80_add = 335,                         // z80_add
        S_z80_and = 336,                         // z80_and
        S_z80_bit = 337,                         // z80_bit
        S_z80_call = 338,                        // z80_call
        S_z80_ccf = 339,                         // z80_ccf
        S_z80_cp = 340,                          // z80_cp
        S_z80_cpl = 341,                         // z80_cpl
        S_z80_daa = 342,                         // z80_daa
        S_z80_dec = 343,                         // z80_dec
        S_z80_di = 344,                          // z80_di
        S_z80_ei = 345,                          // z80_ei
        S_z80_halt = 346,                        // z80_halt
        S_z80_inc = 347,                         // z80_inc
        S_z80_jp = 348,                          // z80_jp
        S_z80_jr = 349,                          // z80_jr
        S_z80_ldi = 350,                         // z80_ldi
        S_z80_ldd = 351,                         // z80_ldd
        S_z80_ldio = 352,                        // z80_ldio
        S_c_ind = 353,                           // c_ind
        S_z80_ld = 354,                          // z80_ld
        S_z80_ld_hl = 355,                       // z80_ld_hl
        S_z80_ld_sp = 356,                       // z80_ld_sp
        S_z80_ld_mem = 357,                      // z80_ld_mem
        S_z80_ld_c_ind = 358,                    // z80_ld_c_ind
        S_z80_ld_rr = 359,                       // z80_ld_rr
        S_z80_ld_r_no_a = 360,                   // z80_ld_r_no_a
        S_z80_ld_a = 361,                        // z80_ld_a
        S_z80_ld_ss = 362,                       // z80_ld_ss
        S_z80_nop = 363,                         // z80_nop
        S_z80_or = 364,                          // z80_or
        S_z80_pop = 365,                         // z80_pop
        S_z80_push = 366,                        // z80_push
        S_z80_res = 367,                         // z80_res
        S_z80_ret = 368,                         // z80_ret
        S_z80_reti = 369,                        // z80_reti
        S_z80_rl = 370,                          // z80_rl
        S_z80_rla = 371,                         // z80_rla
        S_z80_rlc = 372,                         // z80_rlc
        S_z80_rlca = 373,                        // z80_rlca
        S_z80_rr = 374,                          // z80_rr
        S_z80_rra = 375,                         // z80_rra
        S_z80_rrc = 376,                         // z80_rrc
        S_z80_rrca = 377,                        // z80_rrca
        S_z80_rst = 378,                         // z80_rst
        S_z80_sbc = 379,                         // z80_sbc
        S_z80_scf = 380,                         // z80_scf
        S_z80_set = 381,                         // z80_set
        S_z80_sla = 382,                         // z80_sla
        S_z80_sra = 383,                         // z80_sra
        S_z80_srl = 384,                         // z80_srl
        S_z80_stop = 385,                        // z80_stop
        S_z80_sub = 386,                         // z80_sub
        S_z80_swap = 387,                        // z80_swap
        S_z80_xor = 388,                         // z80_xor
        S_op_mem_ind = 389,                      // op_mem_ind
        S_op_a_r = 390,                          // op_a_r
        S_op_a_n = 391,                          // op_a_n
        S_MODE_A = 392,                          // MODE_A
        S_MODE_B = 393,                          // MODE_B
        S_MODE_C = 394,                          // MODE_C
        S_MODE_D = 395,                          // MODE_D
        S_MODE_E = 396,                          // MODE_E
        S_MODE_H = 397,                          // MODE_H
        S_MODE_L = 398,                          // MODE_L
        S_ccode_expr = 399,                      // ccode_expr
        S_ccode = 400,                           // ccode
        S_reg_r = 401,                           // reg_r
        S_reg_r_no_a = 402,                      // reg_r_no_a
        S_reg_a = 403,                           // reg_a
        S_reg_tt = 404,                          // reg_tt
        S_reg_ss = 405,                          // reg_ss
        S_reg_rr = 406,                          // reg_rr
        S_hl_ind_inc = 407,                      // hl_ind_inc
        S_hl_ind_dec = 408                       // hl_ind_dec
      };
    };

    /// (Internal) symbol kind.
    typedef symbol_kind::symbol_kind_type symbol_kind_type;

    /// The number of tokens.
    static const symbol_kind_type YYNTOKENS = symbol_kind::YYNTOKENS;

    /// A complete symbol.
    ///
    /// Expects its Base type to provide access to the symbol kind
    /// via kind ().
    ///
    /// Provide access to semantic value.
    template <typename Base>
    struct basic_symbol : Base
    {
      /// Alias to Base.
      typedef Base super_type;

      /// Default constructor.
      basic_symbol () YY_NOEXCEPT
        : value ()
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      basic_symbol (basic_symbol&& that)
        : Base (std::move (that))
        , value ()
      {
        switch (this->kind ())
    {
      case symbol_kind::S_align_spec: // align_spec
        value.move< AlignmentSpec > (std::move (that.value));
        break;

      case symbol_kind::S_assert_type: // assert_type
        value.move< AssertionType > (std::move (that.value));
        break;

      case symbol_kind::S_capture_rept: // capture_rept
      case symbol_kind::S_capture_macro: // capture_macro
        value.move< Capture > (std::move (that.value));
        break;

      case symbol_kind::S_reloc_8bit: // reloc_8bit
      case symbol_kind::S_reloc_8bit_no_str: // reloc_8bit_no_str
      case symbol_kind::S_reloc_8bit_offset: // reloc_8bit_offset
      case symbol_kind::S_reloc_16bit: // reloc_16bit
      case symbol_kind::S_reloc_16bit_no_str: // reloc_16bit_no_str
      case symbol_kind::S_relocexpr: // relocexpr
      case symbol_kind::S_relocexpr_no_str: // relocexpr_no_str
      case symbol_kind::S_op_mem_ind: // op_mem_ind
      case symbol_kind::S_op_a_n: // op_a_n
        value.move< Expression > (std::move (that.value));
        break;

      case symbol_kind::S_for_args: // for_args
        value.move< ForArgs > (std::move (that.value));
        break;

      case symbol_kind::S_compound_eq: // compound_eq
        value.move< RPNCommand > (std::move (that.value));
        break;

      case symbol_kind::S_sect_mod: // sect_mod
        value.move< SectionModifier > (std::move (that.value));
        break;

      case symbol_kind::S_sect_attrs: // sect_attrs
        value.move< SectionSpec > (std::move (that.value));
        break;

      case symbol_kind::S_strfmt_args: // strfmt_args
      case symbol_kind::S_strfmt_va_args: // strfmt_va_args
        value.move< StrFmtArgList > (std::move (that.value));
        break;

      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_shift_const: // shift_const
      case symbol_kind::S_rs_uconst: // rs_uconst
      case symbol_kind::S_bit_const: // bit_const
      case symbol_kind::S_uconst: // uconst
      case symbol_kind::S_const: // const
      case symbol_kind::S_const_no_str: // const_no_str
      case symbol_kind::S_const_8bit: // const_8bit
      case symbol_kind::S_opt_q_arg: // opt_q_arg
      case symbol_kind::S_sect_type: // sect_type
      case symbol_kind::S_sect_org: // sect_org
      case symbol_kind::S_op_a_r: // op_a_r
      case symbol_kind::S_ccode_expr: // ccode_expr
      case symbol_kind::S_ccode: // ccode
      case symbol_kind::S_reg_r: // reg_r
      case symbol_kind::S_reg_r_no_a: // reg_r_no_a
      case symbol_kind::S_reg_a: // reg_a
      case symbol_kind::S_reg_tt: // reg_tt
      case symbol_kind::S_reg_ss: // reg_ss
      case symbol_kind::S_reg_rr: // reg_rr
        value.move< int32_t > (std::move (that.value));
        break;

      case symbol_kind::S_macro_args: // macro_args
        value.move< std::shared_ptr<MacroArgs> > (std::move (that.value));
        break;

      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_LABEL: // "label"
      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_LOCAL_ID: // "local identifier"
      case symbol_kind::S_ANON: // "anonymous label"
      case symbol_kind::S_def_id: // def_id
      case symbol_kind::S_redef_id: // redef_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_scoped_anon_id: // scoped_anon_id
      case symbol_kind::S_string: // string
      case symbol_kind::S_strcat_args: // strcat_args
        value.move< std::string > (std::move (that.value));
        break;

      case symbol_kind::S_ds_args: // ds_args
        value.move< std::vector<Expression> > (std::move (that.value));
        break;

      case symbol_kind::S_purge_args: // purge_args
        value.move< std::vector<std::string> > (std::move (that.value));
        break;

      default:
        break;
    }

      }
#endif

      /// Copy constructor.
      basic_symbol (const basic_symbol& that);

      /// Constructors for typed symbols.
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t)
        : Base (t)
      {}
#else
      basic_symbol (typename Base::kind_type t)
        : Base (t)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, AlignmentSpec&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const AlignmentSpec& v)
        : Base (t)
        , value (v)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, AssertionType&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const AssertionType& v)
        : Base (t)
        , value (v)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Capture&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Capture& v)
        : Base (t)
        , value (v)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Expression&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Expression& v)
        : Base (t)
        , value (v)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, ForArgs&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const ForArgs& v)
        : Base (t)
        , value (v)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, RPNCommand&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const RPNCommand& v)
        : Base (t)
        , value (v)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, SectionModifier&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const SectionModifier& v)
        : Base (t)
        , value (v)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, SectionSpec&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const SectionSpec& v)
        : Base (t)
        , value (v)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, StrFmtArgList&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const StrFmtArgList& v)
        : Base (t)
        , value (v)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, int32_t&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const int32_t& v)
        : Base (t)
        , value (v)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::shared_ptr<MacroArgs>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::shared_ptr<MacroArgs>& v)
        : Base (t)
        , value (v)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::string&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::string& v)
        : Base (t)
        , value (v)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::vector<Expression>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::vector<Expression>& v)
        : Base (t)
        , value (v)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::vector<std::string>&& v)
        : Base (t)
        , value (std::move (v))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::vector<std::string>& v)
        : Base (t)
        , value (v)
      {}
#endif

      /// Destroy the symbol.
      ~basic_symbol ()
      {
        clear ();
      }



      /// Destroy contents, and record that is empty.
      void clear () YY_NOEXCEPT
      {
        // User destructor.
        symbol_kind_type yykind = this->kind ();
        basic_symbol<Base>& yysym = *this;
        (void) yysym;
        switch (yykind)
        {
       default:
          break;
        }

        // Value type destructor.
switch (yykind)
    {
      case symbol_kind::S_align_spec: // align_spec
        value.template destroy< AlignmentSpec > ();
        break;

      case symbol_kind::S_assert_type: // assert_type
        value.template destroy< AssertionType > ();
        break;

      case symbol_kind::S_capture_rept: // capture_rept
      case symbol_kind::S_capture_macro: // capture_macro
        value.template destroy< Capture > ();
        break;

      case symbol_kind::S_reloc_8bit: // reloc_8bit
      case symbol_kind::S_reloc_8bit_no_str: // reloc_8bit_no_str
      case symbol_kind::S_reloc_8bit_offset: // reloc_8bit_offset
      case symbol_kind::S_reloc_16bit: // reloc_16bit
      case symbol_kind::S_reloc_16bit_no_str: // reloc_16bit_no_str
      case symbol_kind::S_relocexpr: // relocexpr
      case symbol_kind::S_relocexpr_no_str: // relocexpr_no_str
      case symbol_kind::S_op_mem_ind: // op_mem_ind
      case symbol_kind::S_op_a_n: // op_a_n
        value.template destroy< Expression > ();
        break;

      case symbol_kind::S_for_args: // for_args
        value.template destroy< ForArgs > ();
        break;

      case symbol_kind::S_compound_eq: // compound_eq
        value.template destroy< RPNCommand > ();
        break;

      case symbol_kind::S_sect_mod: // sect_mod
        value.template destroy< SectionModifier > ();
        break;

      case symbol_kind::S_sect_attrs: // sect_attrs
        value.template destroy< SectionSpec > ();
        break;

      case symbol_kind::S_strfmt_args: // strfmt_args
      case symbol_kind::S_strfmt_va_args: // strfmt_va_args
        value.template destroy< StrFmtArgList > ();
        break;

      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_shift_const: // shift_const
      case symbol_kind::S_rs_uconst: // rs_uconst
      case symbol_kind::S_bit_const: // bit_const
      case symbol_kind::S_uconst: // uconst
      case symbol_kind::S_const: // const
      case symbol_kind::S_const_no_str: // const_no_str
      case symbol_kind::S_const_8bit: // const_8bit
      case symbol_kind::S_opt_q_arg: // opt_q_arg
      case symbol_kind::S_sect_type: // sect_type
      case symbol_kind::S_sect_org: // sect_org
      case symbol_kind::S_op_a_r: // op_a_r
      case symbol_kind::S_ccode_expr: // ccode_expr
      case symbol_kind::S_ccode: // ccode
      case symbol_kind::S_reg_r: // reg_r
      case symbol_kind::S_reg_r_no_a: // reg_r_no_a
      case symbol_kind::S_reg_a: // reg_a
      case symbol_kind::S_reg_tt: // reg_tt
      case symbol_kind::S_reg_ss: // reg_ss
      case symbol_kind::S_reg_rr: // reg_rr
        value.template destroy< int32_t > ();
        break;

      case symbol_kind::S_macro_args: // macro_args
        value.template destroy< std::shared_ptr<MacroArgs> > ();
        break;

      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_LABEL: // "label"
      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_LOCAL_ID: // "local identifier"
      case symbol_kind::S_ANON: // "anonymous label"
      case symbol_kind::S_def_id: // def_id
      case symbol_kind::S_redef_id: // redef_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_scoped_anon_id: // scoped_anon_id
      case symbol_kind::S_string: // string
      case symbol_kind::S_strcat_args: // strcat_args
        value.template destroy< std::string > ();
        break;

      case symbol_kind::S_ds_args: // ds_args
        value.template destroy< std::vector<Expression> > ();
        break;

      case symbol_kind::S_purge_args: // purge_args
        value.template destroy< std::vector<std::string> > ();
        break;

      default:
        break;
    }

        Base::clear ();
      }

      /// The user-facing name of this symbol.
      const char *name () const YY_NOEXCEPT
      {
        return parser::symbol_name (this->kind ());
      }

      /// Backward compatibility (Bison 3.6).
      symbol_kind_type type_get () const YY_NOEXCEPT;

      /// Whether empty.
      bool empty () const YY_NOEXCEPT;

      /// Destructive move, \a s is emptied into this.
      void move (basic_symbol& s);

      /// The semantic value.
      value_type value;

    private:
#if YY_CPLUSPLUS < 201103L
      /// Assignment operator.
      basic_symbol& operator= (const basic_symbol& that);
#endif
    };

    /// Type access provider for token (enum) based symbols.
    struct by_kind
    {
      /// The symbol kind as needed by the constructor.
      typedef token_kind_type kind_type;

      /// Default constructor.
      by_kind () YY_NOEXCEPT;

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      by_kind (by_kind&& that) YY_NOEXCEPT;
#endif

      /// Copy constructor.
      by_kind (const by_kind& that) YY_NOEXCEPT;

      /// Constructor from (external) token numbers.
      by_kind (kind_type t) YY_NOEXCEPT;



      /// Record that this symbol is empty.
      void clear () YY_NOEXCEPT;

      /// Steal the symbol kind from \a that.
      void move (by_kind& that);

      /// The (internal) type number (corresponding to \a type).
      /// \a empty when empty.
      symbol_kind_type kind () const YY_NOEXCEPT;

      /// Backward compatibility (Bison 3.6).
      symbol_kind_type type_get () const YY_NOEXCEPT;

      /// The symbol kind.
      /// \a S_YYEMPTY when empty.
      symbol_kind_type kind_;
    };

    /// Backward compatibility for a private implementation detail (Bison 3.6).
    typedef by_kind by_type;

    /// "External" symbols: returned by the scanner.
    struct symbol_type : basic_symbol<by_kind>
    {
      /// Superclass.
      typedef basic_symbol<by_kind> super_type;

      /// Empty symbol.
      symbol_type () YY_NOEXCEPT {}

      /// Constructor for valueless symbols, and symbols from each type.
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok)
        : super_type (token_kind_type (tok))
#else
      symbol_type (int tok)
        : super_type (token_kind_type (tok))
#endif
      {}
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, int32_t v)
        : super_type (token_kind_type (tok), std::move (v))
#else
      symbol_type (int tok, const int32_t& v)
        : super_type (token_kind_type (tok), v)
#endif
      {}
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, std::string v)
        : super_type (token_kind_type (tok), std::move (v))
#else
      symbol_type (int tok, const std::string& v)
        : super_type (token_kind_type (tok), v)
#endif
      {}
    };

    /// Build a parser object.
    parser ();
    virtual ~parser ();

#if 201103L <= YY_CPLUSPLUS
    /// Non copyable.
    parser (const parser&) = delete;
    /// Non copyable.
    parser& operator= (const parser&) = delete;
#endif

    /// Parse.  An alias for parse ().
    /// \returns  0 iff parsing succeeded.
    int operator() ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

#if YYDEBUG
    /// The current debugging stream.
    std::ostream& debug_stream () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);
#endif

    /// Report a syntax error.
    /// \param msg    a description of the syntax error.
    virtual void error (const std::string& msg);

    /// Report a syntax error.
    void error (const syntax_error& err);

    /// The user-facing name of the symbol whose (internal) number is
    /// YYSYMBOL.  No bounds checking.
    static const char *symbol_name (symbol_kind_type yysymbol);

    // Implementation of make_symbol for each token kind.
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_YYEOF ()
      {
        return symbol_type (token::YYEOF);
      }
#else
      static
      symbol_type
      make_YYEOF ()
      {
        return symbol_type (token::YYEOF);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_YYerror ()
      {
        return symbol_type (token::YYerror);
      }
#else
      static
      symbol_type
      make_YYerror ()
      {
        return symbol_type (token::YYerror);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_YYUNDEF ()
      {
        return symbol_type (token::YYUNDEF);
      }
#else
      static
      symbol_type
      make_YYUNDEF ()
      {
        return symbol_type (token::YYUNDEF);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NUMBER (int32_t v)
      {
        return symbol_type (token::NUMBER, std::move (v));
      }
#else
      static
      symbol_type
      make_NUMBER (const int32_t& v)
      {
        return symbol_type (token::NUMBER, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_STRING (std::string v)
      {
        return symbol_type (token::STRING, std::move (v));
      }
#else
      static
      symbol_type
      make_STRING (const std::string& v)
      {
        return symbol_type (token::STRING, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PERIOD ()
      {
        return symbol_type (token::PERIOD);
      }
#else
      static
      symbol_type
      make_PERIOD ()
      {
        return symbol_type (token::PERIOD);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_COMMA ()
      {
        return symbol_type (token::COMMA);
      }
#else
      static
      symbol_type
      make_COMMA ()
      {
        return symbol_type (token::COMMA);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_COLON ()
      {
        return symbol_type (token::COLON);
      }
#else
      static
      symbol_type
      make_COLON ()
      {
        return symbol_type (token::COLON);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DOUBLE_COLON ()
      {
        return symbol_type (token::DOUBLE_COLON);
      }
#else
      static
      symbol_type
      make_DOUBLE_COLON ()
      {
        return symbol_type (token::DOUBLE_COLON);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LBRACK ()
      {
        return symbol_type (token::LBRACK);
      }
#else
      static
      symbol_type
      make_LBRACK ()
      {
        return symbol_type (token::LBRACK);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RBRACK ()
      {
        return symbol_type (token::RBRACK);
      }
#else
      static
      symbol_type
      make_RBRACK ()
      {
        return symbol_type (token::RBRACK);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LPAREN ()
      {
        return symbol_type (token::LPAREN);
      }
#else
      static
      symbol_type
      make_LPAREN ()
      {
        return symbol_type (token::LPAREN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RPAREN ()
      {
        return symbol_type (token::RPAREN);
      }
#else
      static
      symbol_type
      make_RPAREN ()
      {
        return symbol_type (token::RPAREN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NEWLINE ()
      {
        return symbol_type (token::NEWLINE);
      }
#else
      static
      symbol_type
      make_NEWLINE ()
      {
        return symbol_type (token::NEWLINE);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_LOGICNOT ()
      {
        return symbol_type (token::OP_LOGICNOT);
      }
#else
      static
      symbol_type
      make_OP_LOGICNOT ()
      {
        return symbol_type (token::OP_LOGICNOT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_LOGICAND ()
      {
        return symbol_type (token::OP_LOGICAND);
      }
#else
      static
      symbol_type
      make_OP_LOGICAND ()
      {
        return symbol_type (token::OP_LOGICAND);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_LOGICOR ()
      {
        return symbol_type (token::OP_LOGICOR);
      }
#else
      static
      symbol_type
      make_OP_LOGICOR ()
      {
        return symbol_type (token::OP_LOGICOR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_LOGICGT ()
      {
        return symbol_type (token::OP_LOGICGT);
      }
#else
      static
      symbol_type
      make_OP_LOGICGT ()
      {
        return symbol_type (token::OP_LOGICGT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_LOGICLT ()
      {
        return symbol_type (token::OP_LOGICLT);
      }
#else
      static
      symbol_type
      make_OP_LOGICLT ()
      {
        return symbol_type (token::OP_LOGICLT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_LOGICGE ()
      {
        return symbol_type (token::OP_LOGICGE);
      }
#else
      static
      symbol_type
      make_OP_LOGICGE ()
      {
        return symbol_type (token::OP_LOGICGE);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_LOGICLE ()
      {
        return symbol_type (token::OP_LOGICLE);
      }
#else
      static
      symbol_type
      make_OP_LOGICLE ()
      {
        return symbol_type (token::OP_LOGICLE);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_LOGICNE ()
      {
        return symbol_type (token::OP_LOGICNE);
      }
#else
      static
      symbol_type
      make_OP_LOGICNE ()
      {
        return symbol_type (token::OP_LOGICNE);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_LOGICEQU ()
      {
        return symbol_type (token::OP_LOGICEQU);
      }
#else
      static
      symbol_type
      make_OP_LOGICEQU ()
      {
        return symbol_type (token::OP_LOGICEQU);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_ADD ()
      {
        return symbol_type (token::OP_ADD);
      }
#else
      static
      symbol_type
      make_OP_ADD ()
      {
        return symbol_type (token::OP_ADD);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_SUB ()
      {
        return symbol_type (token::OP_SUB);
      }
#else
      static
      symbol_type
      make_OP_SUB ()
      {
        return symbol_type (token::OP_SUB);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_OR ()
      {
        return symbol_type (token::OP_OR);
      }
#else
      static
      symbol_type
      make_OP_OR ()
      {
        return symbol_type (token::OP_OR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_XOR ()
      {
        return symbol_type (token::OP_XOR);
      }
#else
      static
      symbol_type
      make_OP_XOR ()
      {
        return symbol_type (token::OP_XOR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_AND ()
      {
        return symbol_type (token::OP_AND);
      }
#else
      static
      symbol_type
      make_OP_AND ()
      {
        return symbol_type (token::OP_AND);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_SHL ()
      {
        return symbol_type (token::OP_SHL);
      }
#else
      static
      symbol_type
      make_OP_SHL ()
      {
        return symbol_type (token::OP_SHL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_SHR ()
      {
        return symbol_type (token::OP_SHR);
      }
#else
      static
      symbol_type
      make_OP_SHR ()
      {
        return symbol_type (token::OP_SHR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_USHR ()
      {
        return symbol_type (token::OP_USHR);
      }
#else
      static
      symbol_type
      make_OP_USHR ()
      {
        return symbol_type (token::OP_USHR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_MUL ()
      {
        return symbol_type (token::OP_MUL);
      }
#else
      static
      symbol_type
      make_OP_MUL ()
      {
        return symbol_type (token::OP_MUL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_DIV ()
      {
        return symbol_type (token::OP_DIV);
      }
#else
      static
      symbol_type
      make_OP_DIV ()
      {
        return symbol_type (token::OP_DIV);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_MOD ()
      {
        return symbol_type (token::OP_MOD);
      }
#else
      static
      symbol_type
      make_OP_MOD ()
      {
        return symbol_type (token::OP_MOD);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_NOT ()
      {
        return symbol_type (token::OP_NOT);
      }
#else
      static
      symbol_type
      make_OP_NOT ()
      {
        return symbol_type (token::OP_NOT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NEG ()
      {
        return symbol_type (token::NEG);
      }
#else
      static
      symbol_type
      make_NEG ()
      {
        return symbol_type (token::NEG);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_EXP ()
      {
        return symbol_type (token::OP_EXP);
      }
#else
      static
      symbol_type
      make_OP_EXP ()
      {
        return symbol_type (token::OP_EXP);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_DEF ()
      {
        return symbol_type (token::OP_DEF);
      }
#else
      static
      symbol_type
      make_OP_DEF ()
      {
        return symbol_type (token::OP_DEF);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_BANK ()
      {
        return symbol_type (token::OP_BANK);
      }
#else
      static
      symbol_type
      make_OP_BANK ()
      {
        return symbol_type (token::OP_BANK);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_ALIGN ()
      {
        return symbol_type (token::OP_ALIGN);
      }
#else
      static
      symbol_type
      make_OP_ALIGN ()
      {
        return symbol_type (token::OP_ALIGN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_SIZEOF ()
      {
        return symbol_type (token::OP_SIZEOF);
      }
#else
      static
      symbol_type
      make_OP_SIZEOF ()
      {
        return symbol_type (token::OP_SIZEOF);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_STARTOF ()
      {
        return symbol_type (token::OP_STARTOF);
      }
#else
      static
      symbol_type
      make_OP_STARTOF ()
      {
        return symbol_type (token::OP_STARTOF);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_SIN ()
      {
        return symbol_type (token::OP_SIN);
      }
#else
      static
      symbol_type
      make_OP_SIN ()
      {
        return symbol_type (token::OP_SIN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_COS ()
      {
        return symbol_type (token::OP_COS);
      }
#else
      static
      symbol_type
      make_OP_COS ()
      {
        return symbol_type (token::OP_COS);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_TAN ()
      {
        return symbol_type (token::OP_TAN);
      }
#else
      static
      symbol_type
      make_OP_TAN ()
      {
        return symbol_type (token::OP_TAN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_ASIN ()
      {
        return symbol_type (token::OP_ASIN);
      }
#else
      static
      symbol_type
      make_OP_ASIN ()
      {
        return symbol_type (token::OP_ASIN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_ACOS ()
      {
        return symbol_type (token::OP_ACOS);
      }
#else
      static
      symbol_type
      make_OP_ACOS ()
      {
        return symbol_type (token::OP_ACOS);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_ATAN ()
      {
        return symbol_type (token::OP_ATAN);
      }
#else
      static
      symbol_type
      make_OP_ATAN ()
      {
        return symbol_type (token::OP_ATAN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_ATAN2 ()
      {
        return symbol_type (token::OP_ATAN2);
      }
#else
      static
      symbol_type
      make_OP_ATAN2 ()
      {
        return symbol_type (token::OP_ATAN2);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_FDIV ()
      {
        return symbol_type (token::OP_FDIV);
      }
#else
      static
      symbol_type
      make_OP_FDIV ()
      {
        return symbol_type (token::OP_FDIV);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_FMUL ()
      {
        return symbol_type (token::OP_FMUL);
      }
#else
      static
      symbol_type
      make_OP_FMUL ()
      {
        return symbol_type (token::OP_FMUL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_FMOD ()
      {
        return symbol_type (token::OP_FMOD);
      }
#else
      static
      symbol_type
      make_OP_FMOD ()
      {
        return symbol_type (token::OP_FMOD);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_POW ()
      {
        return symbol_type (token::OP_POW);
      }
#else
      static
      symbol_type
      make_OP_POW ()
      {
        return symbol_type (token::OP_POW);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_LOG ()
      {
        return symbol_type (token::OP_LOG);
      }
#else
      static
      symbol_type
      make_OP_LOG ()
      {
        return symbol_type (token::OP_LOG);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_ROUND ()
      {
        return symbol_type (token::OP_ROUND);
      }
#else
      static
      symbol_type
      make_OP_ROUND ()
      {
        return symbol_type (token::OP_ROUND);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_CEIL ()
      {
        return symbol_type (token::OP_CEIL);
      }
#else
      static
      symbol_type
      make_OP_CEIL ()
      {
        return symbol_type (token::OP_CEIL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_FLOOR ()
      {
        return symbol_type (token::OP_FLOOR);
      }
#else
      static
      symbol_type
      make_OP_FLOOR ()
      {
        return symbol_type (token::OP_FLOOR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_HIGH ()
      {
        return symbol_type (token::OP_HIGH);
      }
#else
      static
      symbol_type
      make_OP_HIGH ()
      {
        return symbol_type (token::OP_HIGH);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_LOW ()
      {
        return symbol_type (token::OP_LOW);
      }
#else
      static
      symbol_type
      make_OP_LOW ()
      {
        return symbol_type (token::OP_LOW);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_ISCONST ()
      {
        return symbol_type (token::OP_ISCONST);
      }
#else
      static
      symbol_type
      make_OP_ISCONST ()
      {
        return symbol_type (token::OP_ISCONST);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_STRCMP ()
      {
        return symbol_type (token::OP_STRCMP);
      }
#else
      static
      symbol_type
      make_OP_STRCMP ()
      {
        return symbol_type (token::OP_STRCMP);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_STRIN ()
      {
        return symbol_type (token::OP_STRIN);
      }
#else
      static
      symbol_type
      make_OP_STRIN ()
      {
        return symbol_type (token::OP_STRIN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_STRRIN ()
      {
        return symbol_type (token::OP_STRRIN);
      }
#else
      static
      symbol_type
      make_OP_STRRIN ()
      {
        return symbol_type (token::OP_STRRIN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_STRSUB ()
      {
        return symbol_type (token::OP_STRSUB);
      }
#else
      static
      symbol_type
      make_OP_STRSUB ()
      {
        return symbol_type (token::OP_STRSUB);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_STRLEN ()
      {
        return symbol_type (token::OP_STRLEN);
      }
#else
      static
      symbol_type
      make_OP_STRLEN ()
      {
        return symbol_type (token::OP_STRLEN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_STRCAT ()
      {
        return symbol_type (token::OP_STRCAT);
      }
#else
      static
      symbol_type
      make_OP_STRCAT ()
      {
        return symbol_type (token::OP_STRCAT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_STRUPR ()
      {
        return symbol_type (token::OP_STRUPR);
      }
#else
      static
      symbol_type
      make_OP_STRUPR ()
      {
        return symbol_type (token::OP_STRUPR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_STRLWR ()
      {
        return symbol_type (token::OP_STRLWR);
      }
#else
      static
      symbol_type
      make_OP_STRLWR ()
      {
        return symbol_type (token::OP_STRLWR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_STRRPL ()
      {
        return symbol_type (token::OP_STRRPL);
      }
#else
      static
      symbol_type
      make_OP_STRRPL ()
      {
        return symbol_type (token::OP_STRRPL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_STRFMT ()
      {
        return symbol_type (token::OP_STRFMT);
      }
#else
      static
      symbol_type
      make_OP_STRFMT ()
      {
        return symbol_type (token::OP_STRFMT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_CHARLEN ()
      {
        return symbol_type (token::OP_CHARLEN);
      }
#else
      static
      symbol_type
      make_OP_CHARLEN ()
      {
        return symbol_type (token::OP_CHARLEN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_CHARSUB ()
      {
        return symbol_type (token::OP_CHARSUB);
      }
#else
      static
      symbol_type
      make_OP_CHARSUB ()
      {
        return symbol_type (token::OP_CHARSUB);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OP_INCHARMAP ()
      {
        return symbol_type (token::OP_INCHARMAP);
      }
#else
      static
      symbol_type
      make_OP_INCHARMAP ()
      {
        return symbol_type (token::OP_INCHARMAP);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LABEL (std::string v)
      {
        return symbol_type (token::LABEL, std::move (v));
      }
#else
      static
      symbol_type
      make_LABEL (const std::string& v)
      {
        return symbol_type (token::LABEL, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ID (std::string v)
      {
        return symbol_type (token::ID, std::move (v));
      }
#else
      static
      symbol_type
      make_ID (const std::string& v)
      {
        return symbol_type (token::ID, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LOCAL_ID (std::string v)
      {
        return symbol_type (token::LOCAL_ID, std::move (v));
      }
#else
      static
      symbol_type
      make_LOCAL_ID (const std::string& v)
      {
        return symbol_type (token::LOCAL_ID, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ANON (std::string v)
      {
        return symbol_type (token::ANON, std::move (v));
      }
#else
      static
      symbol_type
      make_ANON (const std::string& v)
      {
        return symbol_type (token::ANON, v);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_EQU ()
      {
        return symbol_type (token::POP_EQU);
      }
#else
      static
      symbol_type
      make_POP_EQU ()
      {
        return symbol_type (token::POP_EQU);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_EQUAL ()
      {
        return symbol_type (token::POP_EQUAL);
      }
#else
      static
      symbol_type
      make_POP_EQUAL ()
      {
        return symbol_type (token::POP_EQUAL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_EQUS ()
      {
        return symbol_type (token::POP_EQUS);
      }
#else
      static
      symbol_type
      make_POP_EQUS ()
      {
        return symbol_type (token::POP_EQUS);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_ADDEQ ()
      {
        return symbol_type (token::POP_ADDEQ);
      }
#else
      static
      symbol_type
      make_POP_ADDEQ ()
      {
        return symbol_type (token::POP_ADDEQ);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_SUBEQ ()
      {
        return symbol_type (token::POP_SUBEQ);
      }
#else
      static
      symbol_type
      make_POP_SUBEQ ()
      {
        return symbol_type (token::POP_SUBEQ);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_MULEQ ()
      {
        return symbol_type (token::POP_MULEQ);
      }
#else
      static
      symbol_type
      make_POP_MULEQ ()
      {
        return symbol_type (token::POP_MULEQ);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_DIVEQ ()
      {
        return symbol_type (token::POP_DIVEQ);
      }
#else
      static
      symbol_type
      make_POP_DIVEQ ()
      {
        return symbol_type (token::POP_DIVEQ);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_MODEQ ()
      {
        return symbol_type (token::POP_MODEQ);
      }
#else
      static
      symbol_type
      make_POP_MODEQ ()
      {
        return symbol_type (token::POP_MODEQ);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_OREQ ()
      {
        return symbol_type (token::POP_OREQ);
      }
#else
      static
      symbol_type
      make_POP_OREQ ()
      {
        return symbol_type (token::POP_OREQ);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_XOREQ ()
      {
        return symbol_type (token::POP_XOREQ);
      }
#else
      static
      symbol_type
      make_POP_XOREQ ()
      {
        return symbol_type (token::POP_XOREQ);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_ANDEQ ()
      {
        return symbol_type (token::POP_ANDEQ);
      }
#else
      static
      symbol_type
      make_POP_ANDEQ ()
      {
        return symbol_type (token::POP_ANDEQ);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_SHLEQ ()
      {
        return symbol_type (token::POP_SHLEQ);
      }
#else
      static
      symbol_type
      make_POP_SHLEQ ()
      {
        return symbol_type (token::POP_SHLEQ);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_SHREQ ()
      {
        return symbol_type (token::POP_SHREQ);
      }
#else
      static
      symbol_type
      make_POP_SHREQ ()
      {
        return symbol_type (token::POP_SHREQ);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_INCLUDE ()
      {
        return symbol_type (token::POP_INCLUDE);
      }
#else
      static
      symbol_type
      make_POP_INCLUDE ()
      {
        return symbol_type (token::POP_INCLUDE);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_PRINT ()
      {
        return symbol_type (token::POP_PRINT);
      }
#else
      static
      symbol_type
      make_POP_PRINT ()
      {
        return symbol_type (token::POP_PRINT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_PRINTLN ()
      {
        return symbol_type (token::POP_PRINTLN);
      }
#else
      static
      symbol_type
      make_POP_PRINTLN ()
      {
        return symbol_type (token::POP_PRINTLN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_IF ()
      {
        return symbol_type (token::POP_IF);
      }
#else
      static
      symbol_type
      make_POP_IF ()
      {
        return symbol_type (token::POP_IF);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_ELIF ()
      {
        return symbol_type (token::POP_ELIF);
      }
#else
      static
      symbol_type
      make_POP_ELIF ()
      {
        return symbol_type (token::POP_ELIF);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_ELSE ()
      {
        return symbol_type (token::POP_ELSE);
      }
#else
      static
      symbol_type
      make_POP_ELSE ()
      {
        return symbol_type (token::POP_ELSE);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_ENDC ()
      {
        return symbol_type (token::POP_ENDC);
      }
#else
      static
      symbol_type
      make_POP_ENDC ()
      {
        return symbol_type (token::POP_ENDC);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_EXPORT ()
      {
        return symbol_type (token::POP_EXPORT);
      }
#else
      static
      symbol_type
      make_POP_EXPORT ()
      {
        return symbol_type (token::POP_EXPORT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_DB ()
      {
        return symbol_type (token::POP_DB);
      }
#else
      static
      symbol_type
      make_POP_DB ()
      {
        return symbol_type (token::POP_DB);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_DS ()
      {
        return symbol_type (token::POP_DS);
      }
#else
      static
      symbol_type
      make_POP_DS ()
      {
        return symbol_type (token::POP_DS);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_DW ()
      {
        return symbol_type (token::POP_DW);
      }
#else
      static
      symbol_type
      make_POP_DW ()
      {
        return symbol_type (token::POP_DW);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_DL ()
      {
        return symbol_type (token::POP_DL);
      }
#else
      static
      symbol_type
      make_POP_DL ()
      {
        return symbol_type (token::POP_DL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_SECTION ()
      {
        return symbol_type (token::POP_SECTION);
      }
#else
      static
      symbol_type
      make_POP_SECTION ()
      {
        return symbol_type (token::POP_SECTION);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_FRAGMENT ()
      {
        return symbol_type (token::POP_FRAGMENT);
      }
#else
      static
      symbol_type
      make_POP_FRAGMENT ()
      {
        return symbol_type (token::POP_FRAGMENT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_ENDSECTION ()
      {
        return symbol_type (token::POP_ENDSECTION);
      }
#else
      static
      symbol_type
      make_POP_ENDSECTION ()
      {
        return symbol_type (token::POP_ENDSECTION);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_RB ()
      {
        return symbol_type (token::POP_RB);
      }
#else
      static
      symbol_type
      make_POP_RB ()
      {
        return symbol_type (token::POP_RB);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_RW ()
      {
        return symbol_type (token::POP_RW);
      }
#else
      static
      symbol_type
      make_POP_RW ()
      {
        return symbol_type (token::POP_RW);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_MACRO ()
      {
        return symbol_type (token::POP_MACRO);
      }
#else
      static
      symbol_type
      make_POP_MACRO ()
      {
        return symbol_type (token::POP_MACRO);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_ENDM ()
      {
        return symbol_type (token::POP_ENDM);
      }
#else
      static
      symbol_type
      make_POP_ENDM ()
      {
        return symbol_type (token::POP_ENDM);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_RSRESET ()
      {
        return symbol_type (token::POP_RSRESET);
      }
#else
      static
      symbol_type
      make_POP_RSRESET ()
      {
        return symbol_type (token::POP_RSRESET);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_RSSET ()
      {
        return symbol_type (token::POP_RSSET);
      }
#else
      static
      symbol_type
      make_POP_RSSET ()
      {
        return symbol_type (token::POP_RSSET);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_UNION ()
      {
        return symbol_type (token::POP_UNION);
      }
#else
      static
      symbol_type
      make_POP_UNION ()
      {
        return symbol_type (token::POP_UNION);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_NEXTU ()
      {
        return symbol_type (token::POP_NEXTU);
      }
#else
      static
      symbol_type
      make_POP_NEXTU ()
      {
        return symbol_type (token::POP_NEXTU);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_ENDU ()
      {
        return symbol_type (token::POP_ENDU);
      }
#else
      static
      symbol_type
      make_POP_ENDU ()
      {
        return symbol_type (token::POP_ENDU);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_INCBIN ()
      {
        return symbol_type (token::POP_INCBIN);
      }
#else
      static
      symbol_type
      make_POP_INCBIN ()
      {
        return symbol_type (token::POP_INCBIN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_REPT ()
      {
        return symbol_type (token::POP_REPT);
      }
#else
      static
      symbol_type
      make_POP_REPT ()
      {
        return symbol_type (token::POP_REPT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_FOR ()
      {
        return symbol_type (token::POP_FOR);
      }
#else
      static
      symbol_type
      make_POP_FOR ()
      {
        return symbol_type (token::POP_FOR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_CHARMAP ()
      {
        return symbol_type (token::POP_CHARMAP);
      }
#else
      static
      symbol_type
      make_POP_CHARMAP ()
      {
        return symbol_type (token::POP_CHARMAP);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_NEWCHARMAP ()
      {
        return symbol_type (token::POP_NEWCHARMAP);
      }
#else
      static
      symbol_type
      make_POP_NEWCHARMAP ()
      {
        return symbol_type (token::POP_NEWCHARMAP);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_SETCHARMAP ()
      {
        return symbol_type (token::POP_SETCHARMAP);
      }
#else
      static
      symbol_type
      make_POP_SETCHARMAP ()
      {
        return symbol_type (token::POP_SETCHARMAP);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_PUSHC ()
      {
        return symbol_type (token::POP_PUSHC);
      }
#else
      static
      symbol_type
      make_POP_PUSHC ()
      {
        return symbol_type (token::POP_PUSHC);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_POPC ()
      {
        return symbol_type (token::POP_POPC);
      }
#else
      static
      symbol_type
      make_POP_POPC ()
      {
        return symbol_type (token::POP_POPC);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_SHIFT ()
      {
        return symbol_type (token::POP_SHIFT);
      }
#else
      static
      symbol_type
      make_POP_SHIFT ()
      {
        return symbol_type (token::POP_SHIFT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_ENDR ()
      {
        return symbol_type (token::POP_ENDR);
      }
#else
      static
      symbol_type
      make_POP_ENDR ()
      {
        return symbol_type (token::POP_ENDR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_BREAK ()
      {
        return symbol_type (token::POP_BREAK);
      }
#else
      static
      symbol_type
      make_POP_BREAK ()
      {
        return symbol_type (token::POP_BREAK);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_LOAD ()
      {
        return symbol_type (token::POP_LOAD);
      }
#else
      static
      symbol_type
      make_POP_LOAD ()
      {
        return symbol_type (token::POP_LOAD);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_ENDL ()
      {
        return symbol_type (token::POP_ENDL);
      }
#else
      static
      symbol_type
      make_POP_ENDL ()
      {
        return symbol_type (token::POP_ENDL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_FAIL ()
      {
        return symbol_type (token::POP_FAIL);
      }
#else
      static
      symbol_type
      make_POP_FAIL ()
      {
        return symbol_type (token::POP_FAIL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_WARN ()
      {
        return symbol_type (token::POP_WARN);
      }
#else
      static
      symbol_type
      make_POP_WARN ()
      {
        return symbol_type (token::POP_WARN);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_FATAL ()
      {
        return symbol_type (token::POP_FATAL);
      }
#else
      static
      symbol_type
      make_POP_FATAL ()
      {
        return symbol_type (token::POP_FATAL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_ASSERT ()
      {
        return symbol_type (token::POP_ASSERT);
      }
#else
      static
      symbol_type
      make_POP_ASSERT ()
      {
        return symbol_type (token::POP_ASSERT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_STATIC_ASSERT ()
      {
        return symbol_type (token::POP_STATIC_ASSERT);
      }
#else
      static
      symbol_type
      make_POP_STATIC_ASSERT ()
      {
        return symbol_type (token::POP_STATIC_ASSERT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_PURGE ()
      {
        return symbol_type (token::POP_PURGE);
      }
#else
      static
      symbol_type
      make_POP_PURGE ()
      {
        return symbol_type (token::POP_PURGE);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_REDEF ()
      {
        return symbol_type (token::POP_REDEF);
      }
#else
      static
      symbol_type
      make_POP_REDEF ()
      {
        return symbol_type (token::POP_REDEF);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_POPS ()
      {
        return symbol_type (token::POP_POPS);
      }
#else
      static
      symbol_type
      make_POP_POPS ()
      {
        return symbol_type (token::POP_POPS);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_PUSHS ()
      {
        return symbol_type (token::POP_PUSHS);
      }
#else
      static
      symbol_type
      make_POP_PUSHS ()
      {
        return symbol_type (token::POP_PUSHS);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_POPO ()
      {
        return symbol_type (token::POP_POPO);
      }
#else
      static
      symbol_type
      make_POP_POPO ()
      {
        return symbol_type (token::POP_POPO);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_PUSHO ()
      {
        return symbol_type (token::POP_PUSHO);
      }
#else
      static
      symbol_type
      make_POP_PUSHO ()
      {
        return symbol_type (token::POP_PUSHO);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_POP_OPT ()
      {
        return symbol_type (token::POP_OPT);
      }
#else
      static
      symbol_type
      make_POP_OPT ()
      {
        return symbol_type (token::POP_OPT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SECT_ROM0 ()
      {
        return symbol_type (token::SECT_ROM0);
      }
#else
      static
      symbol_type
      make_SECT_ROM0 ()
      {
        return symbol_type (token::SECT_ROM0);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SECT_ROMX ()
      {
        return symbol_type (token::SECT_ROMX);
      }
#else
      static
      symbol_type
      make_SECT_ROMX ()
      {
        return symbol_type (token::SECT_ROMX);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SECT_WRAM0 ()
      {
        return symbol_type (token::SECT_WRAM0);
      }
#else
      static
      symbol_type
      make_SECT_WRAM0 ()
      {
        return symbol_type (token::SECT_WRAM0);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SECT_WRAMX ()
      {
        return symbol_type (token::SECT_WRAMX);
      }
#else
      static
      symbol_type
      make_SECT_WRAMX ()
      {
        return symbol_type (token::SECT_WRAMX);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SECT_HRAM ()
      {
        return symbol_type (token::SECT_HRAM);
      }
#else
      static
      symbol_type
      make_SECT_HRAM ()
      {
        return symbol_type (token::SECT_HRAM);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SECT_VRAM ()
      {
        return symbol_type (token::SECT_VRAM);
      }
#else
      static
      symbol_type
      make_SECT_VRAM ()
      {
        return symbol_type (token::SECT_VRAM);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SECT_SRAM ()
      {
        return symbol_type (token::SECT_SRAM);
      }
#else
      static
      symbol_type
      make_SECT_SRAM ()
      {
        return symbol_type (token::SECT_SRAM);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SECT_OAM ()
      {
        return symbol_type (token::SECT_OAM);
      }
#else
      static
      symbol_type
      make_SECT_OAM ()
      {
        return symbol_type (token::SECT_OAM);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_ADC ()
      {
        return symbol_type (token::Z80_ADC);
      }
#else
      static
      symbol_type
      make_Z80_ADC ()
      {
        return symbol_type (token::Z80_ADC);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_ADD ()
      {
        return symbol_type (token::Z80_ADD);
      }
#else
      static
      symbol_type
      make_Z80_ADD ()
      {
        return symbol_type (token::Z80_ADD);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_AND ()
      {
        return symbol_type (token::Z80_AND);
      }
#else
      static
      symbol_type
      make_Z80_AND ()
      {
        return symbol_type (token::Z80_AND);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_BIT ()
      {
        return symbol_type (token::Z80_BIT);
      }
#else
      static
      symbol_type
      make_Z80_BIT ()
      {
        return symbol_type (token::Z80_BIT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_CALL ()
      {
        return symbol_type (token::Z80_CALL);
      }
#else
      static
      symbol_type
      make_Z80_CALL ()
      {
        return symbol_type (token::Z80_CALL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_CCF ()
      {
        return symbol_type (token::Z80_CCF);
      }
#else
      static
      symbol_type
      make_Z80_CCF ()
      {
        return symbol_type (token::Z80_CCF);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_CP ()
      {
        return symbol_type (token::Z80_CP);
      }
#else
      static
      symbol_type
      make_Z80_CP ()
      {
        return symbol_type (token::Z80_CP);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_CPL ()
      {
        return symbol_type (token::Z80_CPL);
      }
#else
      static
      symbol_type
      make_Z80_CPL ()
      {
        return symbol_type (token::Z80_CPL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_DAA ()
      {
        return symbol_type (token::Z80_DAA);
      }
#else
      static
      symbol_type
      make_Z80_DAA ()
      {
        return symbol_type (token::Z80_DAA);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_DEC ()
      {
        return symbol_type (token::Z80_DEC);
      }
#else
      static
      symbol_type
      make_Z80_DEC ()
      {
        return symbol_type (token::Z80_DEC);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_DI ()
      {
        return symbol_type (token::Z80_DI);
      }
#else
      static
      symbol_type
      make_Z80_DI ()
      {
        return symbol_type (token::Z80_DI);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_EI ()
      {
        return symbol_type (token::Z80_EI);
      }
#else
      static
      symbol_type
      make_Z80_EI ()
      {
        return symbol_type (token::Z80_EI);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_HALT ()
      {
        return symbol_type (token::Z80_HALT);
      }
#else
      static
      symbol_type
      make_Z80_HALT ()
      {
        return symbol_type (token::Z80_HALT);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_INC ()
      {
        return symbol_type (token::Z80_INC);
      }
#else
      static
      symbol_type
      make_Z80_INC ()
      {
        return symbol_type (token::Z80_INC);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_JP ()
      {
        return symbol_type (token::Z80_JP);
      }
#else
      static
      symbol_type
      make_Z80_JP ()
      {
        return symbol_type (token::Z80_JP);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_JR ()
      {
        return symbol_type (token::Z80_JR);
      }
#else
      static
      symbol_type
      make_Z80_JR ()
      {
        return symbol_type (token::Z80_JR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_LD ()
      {
        return symbol_type (token::Z80_LD);
      }
#else
      static
      symbol_type
      make_Z80_LD ()
      {
        return symbol_type (token::Z80_LD);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_LDI ()
      {
        return symbol_type (token::Z80_LDI);
      }
#else
      static
      symbol_type
      make_Z80_LDI ()
      {
        return symbol_type (token::Z80_LDI);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_LDD ()
      {
        return symbol_type (token::Z80_LDD);
      }
#else
      static
      symbol_type
      make_Z80_LDD ()
      {
        return symbol_type (token::Z80_LDD);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_LDH ()
      {
        return symbol_type (token::Z80_LDH);
      }
#else
      static
      symbol_type
      make_Z80_LDH ()
      {
        return symbol_type (token::Z80_LDH);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_NOP ()
      {
        return symbol_type (token::Z80_NOP);
      }
#else
      static
      symbol_type
      make_Z80_NOP ()
      {
        return symbol_type (token::Z80_NOP);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_OR ()
      {
        return symbol_type (token::Z80_OR);
      }
#else
      static
      symbol_type
      make_Z80_OR ()
      {
        return symbol_type (token::Z80_OR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_POP ()
      {
        return symbol_type (token::Z80_POP);
      }
#else
      static
      symbol_type
      make_Z80_POP ()
      {
        return symbol_type (token::Z80_POP);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_PUSH ()
      {
        return symbol_type (token::Z80_PUSH);
      }
#else
      static
      symbol_type
      make_Z80_PUSH ()
      {
        return symbol_type (token::Z80_PUSH);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_RES ()
      {
        return symbol_type (token::Z80_RES);
      }
#else
      static
      symbol_type
      make_Z80_RES ()
      {
        return symbol_type (token::Z80_RES);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_RET ()
      {
        return symbol_type (token::Z80_RET);
      }
#else
      static
      symbol_type
      make_Z80_RET ()
      {
        return symbol_type (token::Z80_RET);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_RETI ()
      {
        return symbol_type (token::Z80_RETI);
      }
#else
      static
      symbol_type
      make_Z80_RETI ()
      {
        return symbol_type (token::Z80_RETI);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_RST ()
      {
        return symbol_type (token::Z80_RST);
      }
#else
      static
      symbol_type
      make_Z80_RST ()
      {
        return symbol_type (token::Z80_RST);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_RL ()
      {
        return symbol_type (token::Z80_RL);
      }
#else
      static
      symbol_type
      make_Z80_RL ()
      {
        return symbol_type (token::Z80_RL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_RLA ()
      {
        return symbol_type (token::Z80_RLA);
      }
#else
      static
      symbol_type
      make_Z80_RLA ()
      {
        return symbol_type (token::Z80_RLA);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_RLC ()
      {
        return symbol_type (token::Z80_RLC);
      }
#else
      static
      symbol_type
      make_Z80_RLC ()
      {
        return symbol_type (token::Z80_RLC);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_RLCA ()
      {
        return symbol_type (token::Z80_RLCA);
      }
#else
      static
      symbol_type
      make_Z80_RLCA ()
      {
        return symbol_type (token::Z80_RLCA);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_RR ()
      {
        return symbol_type (token::Z80_RR);
      }
#else
      static
      symbol_type
      make_Z80_RR ()
      {
        return symbol_type (token::Z80_RR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_RRA ()
      {
        return symbol_type (token::Z80_RRA);
      }
#else
      static
      symbol_type
      make_Z80_RRA ()
      {
        return symbol_type (token::Z80_RRA);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_RRC ()
      {
        return symbol_type (token::Z80_RRC);
      }
#else
      static
      symbol_type
      make_Z80_RRC ()
      {
        return symbol_type (token::Z80_RRC);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_RRCA ()
      {
        return symbol_type (token::Z80_RRCA);
      }
#else
      static
      symbol_type
      make_Z80_RRCA ()
      {
        return symbol_type (token::Z80_RRCA);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_SBC ()
      {
        return symbol_type (token::Z80_SBC);
      }
#else
      static
      symbol_type
      make_Z80_SBC ()
      {
        return symbol_type (token::Z80_SBC);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_SCF ()
      {
        return symbol_type (token::Z80_SCF);
      }
#else
      static
      symbol_type
      make_Z80_SCF ()
      {
        return symbol_type (token::Z80_SCF);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_SET ()
      {
        return symbol_type (token::Z80_SET);
      }
#else
      static
      symbol_type
      make_Z80_SET ()
      {
        return symbol_type (token::Z80_SET);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_STOP ()
      {
        return symbol_type (token::Z80_STOP);
      }
#else
      static
      symbol_type
      make_Z80_STOP ()
      {
        return symbol_type (token::Z80_STOP);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_SLA ()
      {
        return symbol_type (token::Z80_SLA);
      }
#else
      static
      symbol_type
      make_Z80_SLA ()
      {
        return symbol_type (token::Z80_SLA);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_SRA ()
      {
        return symbol_type (token::Z80_SRA);
      }
#else
      static
      symbol_type
      make_Z80_SRA ()
      {
        return symbol_type (token::Z80_SRA);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_SRL ()
      {
        return symbol_type (token::Z80_SRL);
      }
#else
      static
      symbol_type
      make_Z80_SRL ()
      {
        return symbol_type (token::Z80_SRL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_SUB ()
      {
        return symbol_type (token::Z80_SUB);
      }
#else
      static
      symbol_type
      make_Z80_SUB ()
      {
        return symbol_type (token::Z80_SUB);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_SWAP ()
      {
        return symbol_type (token::Z80_SWAP);
      }
#else
      static
      symbol_type
      make_Z80_SWAP ()
      {
        return symbol_type (token::Z80_SWAP);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_Z80_XOR ()
      {
        return symbol_type (token::Z80_XOR);
      }
#else
      static
      symbol_type
      make_Z80_XOR ()
      {
        return symbol_type (token::Z80_XOR);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TOKEN_A ()
      {
        return symbol_type (token::TOKEN_A);
      }
#else
      static
      symbol_type
      make_TOKEN_A ()
      {
        return symbol_type (token::TOKEN_A);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TOKEN_B ()
      {
        return symbol_type (token::TOKEN_B);
      }
#else
      static
      symbol_type
      make_TOKEN_B ()
      {
        return symbol_type (token::TOKEN_B);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TOKEN_C ()
      {
        return symbol_type (token::TOKEN_C);
      }
#else
      static
      symbol_type
      make_TOKEN_C ()
      {
        return symbol_type (token::TOKEN_C);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TOKEN_D ()
      {
        return symbol_type (token::TOKEN_D);
      }
#else
      static
      symbol_type
      make_TOKEN_D ()
      {
        return symbol_type (token::TOKEN_D);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TOKEN_E ()
      {
        return symbol_type (token::TOKEN_E);
      }
#else
      static
      symbol_type
      make_TOKEN_E ()
      {
        return symbol_type (token::TOKEN_E);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TOKEN_H ()
      {
        return symbol_type (token::TOKEN_H);
      }
#else
      static
      symbol_type
      make_TOKEN_H ()
      {
        return symbol_type (token::TOKEN_H);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TOKEN_L ()
      {
        return symbol_type (token::TOKEN_L);
      }
#else
      static
      symbol_type
      make_TOKEN_L ()
      {
        return symbol_type (token::TOKEN_L);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MODE_AF ()
      {
        return symbol_type (token::MODE_AF);
      }
#else
      static
      symbol_type
      make_MODE_AF ()
      {
        return symbol_type (token::MODE_AF);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MODE_BC ()
      {
        return symbol_type (token::MODE_BC);
      }
#else
      static
      symbol_type
      make_MODE_BC ()
      {
        return symbol_type (token::MODE_BC);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MODE_DE ()
      {
        return symbol_type (token::MODE_DE);
      }
#else
      static
      symbol_type
      make_MODE_DE ()
      {
        return symbol_type (token::MODE_DE);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MODE_SP ()
      {
        return symbol_type (token::MODE_SP);
      }
#else
      static
      symbol_type
      make_MODE_SP ()
      {
        return symbol_type (token::MODE_SP);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MODE_HL ()
      {
        return symbol_type (token::MODE_HL);
      }
#else
      static
      symbol_type
      make_MODE_HL ()
      {
        return symbol_type (token::MODE_HL);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MODE_HL_DEC ()
      {
        return symbol_type (token::MODE_HL_DEC);
      }
#else
      static
      symbol_type
      make_MODE_HL_DEC ()
      {
        return symbol_type (token::MODE_HL_DEC);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MODE_HL_INC ()
      {
        return symbol_type (token::MODE_HL_INC);
      }
#else
      static
      symbol_type
      make_MODE_HL_INC ()
      {
        return symbol_type (token::MODE_HL_INC);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CC_NZ ()
      {
        return symbol_type (token::CC_NZ);
      }
#else
      static
      symbol_type
      make_CC_NZ ()
      {
        return symbol_type (token::CC_NZ);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CC_Z ()
      {
        return symbol_type (token::CC_Z);
      }
#else
      static
      symbol_type
      make_CC_Z ()
      {
        return symbol_type (token::CC_Z);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CC_NC ()
      {
        return symbol_type (token::CC_NC);
      }
#else
      static
      symbol_type
      make_CC_NC ()
      {
        return symbol_type (token::CC_NC);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EOB ()
      {
        return symbol_type (token::EOB);
      }
#else
      static
      symbol_type
      make_EOB ()
      {
        return symbol_type (token::EOB);
      }
#endif


    class context
    {
    public:
      context (const parser& yyparser, const symbol_type& yyla);
      const symbol_type& lookahead () const YY_NOEXCEPT { return yyla_; }
      symbol_kind_type token () const YY_NOEXCEPT { return yyla_.kind (); }
      /// Put in YYARG at most YYARGN of the expected tokens, and return the
      /// number of tokens stored in YYARG.  If YYARG is null, return the
      /// number of expected tokens (guaranteed to be less than YYNTOKENS).
      int expected_tokens (symbol_kind_type yyarg[], int yyargn) const;

    private:
      const parser& yyparser_;
      const symbol_type& yyla_;
    };

  private:
#if YY_CPLUSPLUS < 201103L
    /// Non copyable.
    parser (const parser&);
    /// Non copyable.
    parser& operator= (const parser&);
#endif

    /// Check the lookahead yytoken.
    /// \returns  true iff the token will be eventually shifted.
    bool yy_lac_check_ (symbol_kind_type yytoken) const;
    /// Establish the initial context if no initial context currently exists.
    /// \returns  true iff the token will be eventually shifted.
    bool yy_lac_establish_ (symbol_kind_type yytoken);
    /// Discard any previous initial lookahead context because of event.
    /// \param event  the event which caused the lookahead to be discarded.
    ///               Only used for debbuging output.
    void yy_lac_discard_ (const char* event);

    /// Stored state numbers (used for stacks).
    typedef short state_type;

    /// The arguments of the error message.
    int yy_syntax_error_arguments_ (const context& yyctx,
                                    symbol_kind_type yyarg[], int yyargn) const;

    /// Generate an error message.
    /// \param yyctx     the context in which the error occurred.
    virtual std::string yysyntax_error_ (const context& yyctx) const;
    /// Compute post-reduction state.
    /// \param yystate   the current state
    /// \param yysym     the nonterminal to push on the stack
    static state_type yy_lr_goto_state_ (state_type yystate, int yysym);

    /// Whether the given \c yypact_ value indicates a defaulted state.
    /// \param yyvalue   the value to check
    static bool yy_pact_value_is_default_ (int yyvalue) YY_NOEXCEPT;

    /// Whether the given \c yytable_ value indicates a syntax error.
    /// \param yyvalue   the value to check
    static bool yy_table_value_is_error_ (int yyvalue) YY_NOEXCEPT;

    static const short yypact_ninf_;
    static const short yytable_ninf_;

    /// Convert a scanner token kind \a t to a symbol kind.
    /// In theory \a t should be a token_kind_type, but character literals
    /// are valid, yet not members of the token_kind_type enum.
    static symbol_kind_type yytranslate_ (int t) YY_NOEXCEPT;



    // Tables.
    // YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
    // STATE-NUM.
    static const short yypact_[];

    // YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
    // Performed when YYTABLE does not specify something else to do.  Zero
    // means the default is an error.
    static const short yydefact_[];

    // YYPGOTO[NTERM-NUM].
    static const short yypgoto_[];

    // YYDEFGOTO[NTERM-NUM].
    static const short yydefgoto_[];

    // YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
    // positive, shift that token.  If negative, reduce the rule whose
    // number is the opposite.  If YYTABLE_NINF, syntax error.
    static const short yytable_[];

    static const short yycheck_[];

    // YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
    // state STATE-NUM.
    static const short yystos_[];

    // YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.
    static const short yyr1_[];

    // YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.
    static const signed char yyr2_[];


#if YYDEBUG
    // YYRLINE[YYN] -- Source line where rule number YYN was defined.
    static const short yyrline_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void yy_reduce_print_ (int r) const;
    /// Print the state stack on the debug stream.
    virtual void yy_stack_print_ () const;

    /// Debugging level.
    int yydebug_;
    /// Debug stream.
    std::ostream* yycdebug_;

    /// \brief Display a symbol kind, value and location.
    /// \param yyo    The output stream.
    /// \param yysym  The symbol.
    template <typename Base>
    void yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const;
#endif

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg     Why this token is reclaimed.
    ///                  If null, print nothing.
    /// \param yysym     The symbol.
    template <typename Base>
    void yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const;

  private:
    /// Type access provider for state based symbols.
    struct by_state
    {
      /// Default constructor.
      by_state () YY_NOEXCEPT;

      /// The symbol kind as needed by the constructor.
      typedef state_type kind_type;

      /// Constructor.
      by_state (kind_type s) YY_NOEXCEPT;

      /// Copy constructor.
      by_state (const by_state& that) YY_NOEXCEPT;

      /// Record that this symbol is empty.
      void clear () YY_NOEXCEPT;

      /// Steal the symbol kind from \a that.
      void move (by_state& that);

      /// The symbol kind (corresponding to \a state).
      /// \a symbol_kind::S_YYEMPTY when empty.
      symbol_kind_type kind () const YY_NOEXCEPT;

      /// The state number used to denote an empty symbol.
      /// We use the initial state, as it does not have a value.
      enum { empty_state = 0 };

      /// The state.
      /// \a empty when empty.
      state_type state;
    };

    /// "Internal" symbol: element of the stack.
    struct stack_symbol_type : basic_symbol<by_state>
    {
      /// Superclass.
      typedef basic_symbol<by_state> super_type;
      /// Construct an empty symbol.
      stack_symbol_type ();
      /// Move or copy construction.
      stack_symbol_type (YY_RVREF (stack_symbol_type) that);
      /// Steal the contents from \a sym to build this.
      stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) sym);
#if YY_CPLUSPLUS < 201103L
      /// Assignment, needed by push_back by some old implementations.
      /// Moves the contents of that.
      stack_symbol_type& operator= (stack_symbol_type& that);

      /// Assignment, needed by push_back by other implementations.
      /// Needed by some other old implementations.
      stack_symbol_type& operator= (const stack_symbol_type& that);
#endif
    };

    /// A stack with random access from its top.
    template <typename T, typename S = std::vector<T> >
    class stack
    {
    public:
      // Hide our reversed order.
      typedef typename S::iterator iterator;
      typedef typename S::const_iterator const_iterator;
      typedef typename S::size_type size_type;
      typedef typename std::ptrdiff_t index_type;

      stack (size_type n = 200) YY_NOEXCEPT
        : seq_ (n)
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Non copyable.
      stack (const stack&) = delete;
      /// Non copyable.
      stack& operator= (const stack&) = delete;
#endif

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      const T&
      operator[] (index_type i) const
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      T&
      operator[] (index_type i)
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Steal the contents of \a t.
      ///
      /// Close to move-semantics.
      void
      push (YY_MOVE_REF (T) t)
      {
        seq_.push_back (T ());
        operator[] (0).move (t);
      }

      /// Pop elements from the stack.
      void
      pop (std::ptrdiff_t n = 1) YY_NOEXCEPT
      {
        for (; 0 < n; --n)
          seq_.pop_back ();
      }

      /// Pop all elements from the stack.
      void
      clear () YY_NOEXCEPT
      {
        seq_.clear ();
      }

      /// Number of elements on the stack.
      index_type
      size () const YY_NOEXCEPT
      {
        return index_type (seq_.size ());
      }

      /// Iterator on top of the stack (going downwards).
      const_iterator
      begin () const YY_NOEXCEPT
      {
        return seq_.begin ();
      }

      /// Bottom of the stack.
      const_iterator
      end () const YY_NOEXCEPT
      {
        return seq_.end ();
      }

      /// Present a slice of the top of a stack.
      class slice
      {
      public:
        slice (const stack& stack, index_type range) YY_NOEXCEPT
          : stack_ (stack)
          , range_ (range)
        {}

        const T&
        operator[] (index_type i) const
        {
          return stack_[range_ - i];
        }

      private:
        const stack& stack_;
        index_type range_;
      };

    private:
#if YY_CPLUSPLUS < 201103L
      /// Non copyable.
      stack (const stack&);
      /// Non copyable.
      stack& operator= (const stack&);
#endif
      /// The wrapped container.
      S seq_;
    };


    /// Stack type.
    typedef stack<stack_symbol_type> stack_type;

    /// The stack.
    stack_type yystack_;
    /// The stack for LAC.
    /// Logically, the yy_lac_stack's lifetime is confined to the function
    /// yy_lac_check_. We just store it as a member of this class to hold
    /// on to the memory and to avoid frequent reallocations.
    /// Since yy_lac_check_ is const, this member must be mutable.
    mutable std::vector<state_type> yylac_stack_;
    /// Whether an initial LAC context was established.
    bool yy_lac_established_;


    /// Push a new state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param sym  the symbol
    /// \warning the contents of \a s.value is stolen.
    void yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym);

    /// Push a new look ahead token on the state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the state
    /// \param sym  the symbol (for its value and location).
    /// \warning the contents of \a sym.value is stolen.
    void yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym);

    /// Pop \a n symbols from the stack.
    void yypop_ (int n = 1) YY_NOEXCEPT;

    /// Constants.
    enum
    {
      yylast_ = 2490,     ///< Last index in yytable_.
      yynnts_ = 198,  ///< Number of nonterminal symbols.
      yyfinal_ = 3 ///< Termination state number.
    };



  };

  inline
  parser::symbol_kind_type
  parser::yytranslate_ (int t) YY_NOEXCEPT
  {
    return static_cast<symbol_kind_type> (t);
  }

  // basic_symbol.
  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
  {
    switch (this->kind ())
    {
      case symbol_kind::S_align_spec: // align_spec
        value.copy< AlignmentSpec > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_assert_type: // assert_type
        value.copy< AssertionType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_capture_rept: // capture_rept
      case symbol_kind::S_capture_macro: // capture_macro
        value.copy< Capture > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_reloc_8bit: // reloc_8bit
      case symbol_kind::S_reloc_8bit_no_str: // reloc_8bit_no_str
      case symbol_kind::S_reloc_8bit_offset: // reloc_8bit_offset
      case symbol_kind::S_reloc_16bit: // reloc_16bit
      case symbol_kind::S_reloc_16bit_no_str: // reloc_16bit_no_str
      case symbol_kind::S_relocexpr: // relocexpr
      case symbol_kind::S_relocexpr_no_str: // relocexpr_no_str
      case symbol_kind::S_op_mem_ind: // op_mem_ind
      case symbol_kind::S_op_a_n: // op_a_n
        value.copy< Expression > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_for_args: // for_args
        value.copy< ForArgs > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_compound_eq: // compound_eq
        value.copy< RPNCommand > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sect_mod: // sect_mod
        value.copy< SectionModifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sect_attrs: // sect_attrs
        value.copy< SectionSpec > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_strfmt_args: // strfmt_args
      case symbol_kind::S_strfmt_va_args: // strfmt_va_args
        value.copy< StrFmtArgList > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_shift_const: // shift_const
      case symbol_kind::S_rs_uconst: // rs_uconst
      case symbol_kind::S_bit_const: // bit_const
      case symbol_kind::S_uconst: // uconst
      case symbol_kind::S_const: // const
      case symbol_kind::S_const_no_str: // const_no_str
      case symbol_kind::S_const_8bit: // const_8bit
      case symbol_kind::S_opt_q_arg: // opt_q_arg
      case symbol_kind::S_sect_type: // sect_type
      case symbol_kind::S_sect_org: // sect_org
      case symbol_kind::S_op_a_r: // op_a_r
      case symbol_kind::S_ccode_expr: // ccode_expr
      case symbol_kind::S_ccode: // ccode
      case symbol_kind::S_reg_r: // reg_r
      case symbol_kind::S_reg_r_no_a: // reg_r_no_a
      case symbol_kind::S_reg_a: // reg_a
      case symbol_kind::S_reg_tt: // reg_tt
      case symbol_kind::S_reg_ss: // reg_ss
      case symbol_kind::S_reg_rr: // reg_rr
        value.copy< int32_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_macro_args: // macro_args
        value.copy< std::shared_ptr<MacroArgs> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_LABEL: // "label"
      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_LOCAL_ID: // "local identifier"
      case symbol_kind::S_ANON: // "anonymous label"
      case symbol_kind::S_def_id: // def_id
      case symbol_kind::S_redef_id: // redef_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_scoped_anon_id: // scoped_anon_id
      case symbol_kind::S_string: // string
      case symbol_kind::S_strcat_args: // strcat_args
        value.copy< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ds_args: // ds_args
        value.copy< std::vector<Expression> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_purge_args: // purge_args
        value.copy< std::vector<std::string> > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }




  template <typename Base>
  parser::symbol_kind_type
  parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


  template <typename Base>
  bool
  parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_align_spec: // align_spec
        value.move< AlignmentSpec > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_assert_type: // assert_type
        value.move< AssertionType > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_capture_rept: // capture_rept
      case symbol_kind::S_capture_macro: // capture_macro
        value.move< Capture > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_reloc_8bit: // reloc_8bit
      case symbol_kind::S_reloc_8bit_no_str: // reloc_8bit_no_str
      case symbol_kind::S_reloc_8bit_offset: // reloc_8bit_offset
      case symbol_kind::S_reloc_16bit: // reloc_16bit
      case symbol_kind::S_reloc_16bit_no_str: // reloc_16bit_no_str
      case symbol_kind::S_relocexpr: // relocexpr
      case symbol_kind::S_relocexpr_no_str: // relocexpr_no_str
      case symbol_kind::S_op_mem_ind: // op_mem_ind
      case symbol_kind::S_op_a_n: // op_a_n
        value.move< Expression > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_for_args: // for_args
        value.move< ForArgs > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_compound_eq: // compound_eq
        value.move< RPNCommand > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_sect_mod: // sect_mod
        value.move< SectionModifier > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_sect_attrs: // sect_attrs
        value.move< SectionSpec > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_strfmt_args: // strfmt_args
      case symbol_kind::S_strfmt_va_args: // strfmt_va_args
        value.move< StrFmtArgList > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_shift_const: // shift_const
      case symbol_kind::S_rs_uconst: // rs_uconst
      case symbol_kind::S_bit_const: // bit_const
      case symbol_kind::S_uconst: // uconst
      case symbol_kind::S_const: // const
      case symbol_kind::S_const_no_str: // const_no_str
      case symbol_kind::S_const_8bit: // const_8bit
      case symbol_kind::S_opt_q_arg: // opt_q_arg
      case symbol_kind::S_sect_type: // sect_type
      case symbol_kind::S_sect_org: // sect_org
      case symbol_kind::S_op_a_r: // op_a_r
      case symbol_kind::S_ccode_expr: // ccode_expr
      case symbol_kind::S_ccode: // ccode
      case symbol_kind::S_reg_r: // reg_r
      case symbol_kind::S_reg_r_no_a: // reg_r_no_a
      case symbol_kind::S_reg_a: // reg_a
      case symbol_kind::S_reg_tt: // reg_tt
      case symbol_kind::S_reg_ss: // reg_ss
      case symbol_kind::S_reg_rr: // reg_rr
        value.move< int32_t > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_macro_args: // macro_args
        value.move< std::shared_ptr<MacroArgs> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_STRING: // "string"
      case symbol_kind::S_LABEL: // "label"
      case symbol_kind::S_ID: // "identifier"
      case symbol_kind::S_LOCAL_ID: // "local identifier"
      case symbol_kind::S_ANON: // "anonymous label"
      case symbol_kind::S_def_id: // def_id
      case symbol_kind::S_redef_id: // redef_id
      case symbol_kind::S_scoped_id: // scoped_id
      case symbol_kind::S_scoped_anon_id: // scoped_anon_id
      case symbol_kind::S_string: // string
      case symbol_kind::S_strcat_args: // strcat_args
        value.move< std::string > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_ds_args: // ds_args
        value.move< std::vector<Expression> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_purge_args: // purge_args
        value.move< std::vector<std::string> > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

  }

  // by_kind.
  inline
  parser::by_kind::by_kind () YY_NOEXCEPT
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  inline
  parser::by_kind::by_kind (by_kind&& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  inline
  parser::by_kind::by_kind (const by_kind& that) YY_NOEXCEPT
    : kind_ (that.kind_)
  {}

  inline
  parser::by_kind::by_kind (token_kind_type t) YY_NOEXCEPT
    : kind_ (yytranslate_ (t))
  {}



  inline
  void
  parser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  inline
  void
  parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  inline
  parser::symbol_kind_type
  parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }


  inline
  parser::symbol_kind_type
  parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }


} // yy
#line 5587 "src/asm/parser.hpp"




#endif // !YY_YY_SRC_ASM_PARSER_HPP_INCLUDED
